*#INCLUDE 'BDDB.CH'

/*-----------------03-07-94 00:12am-----------------
 Defines For BDMS Library Routines
--------------------------------------------------*/

#DEFINE BD_IDLE                           0

#DEFINE BD_OPEN                           1
#DEFINE BD_CLOSE                          2
#DEFINE BD_CREATE                         3
#DEFINE BD_ERROR                          7
#DEFINE BD_OK                             8
#DEFINE BD_CANCEL                         9

#DEFINE BD_DECLARE                       10
#DEFINE BD_INIT                          11
#DEFINE BD_LOAD                          12
#DEFINE BD_PUT                           13
#DEFINE BD_SET                           14
#DEFINE BD_RESET                         15
#DEFINE BD_CLEAR                         16
#DEFINE BD_SCATTER                       17
#DEFINE BD_GATHER                        18
#DEFINE BD_LDCRYPT                       19
#DEFINE BD_PTCRYPT                       20
#DEFINE BD_EMPTY                         21
#DEFINE BD_DB_FAILED                     22
#DEFINE BD_INDEX_FAILED                  23
#DEFINE BD_MISSINGINFO                   24
#DEFINE BD_INVALIDINFO                   25
#DEFINE BD_UPPER                         26
#DEFINE BD_LOWER                         27
#DEFINE BD_PROPER                        28


#DEFINE BD_ADD                           30
#DEFINE BD_EDIT                          31
#DEFINE BD_DELETE                        32
#DEFINE BD_COPY                          33
#DEFINE BD_GET                           34
#DEFINE BD_EXIST                         35
#DEFINE BD_MEMO                          36
#DEFINE BD_REEDIT                        37
#DEFINE BD_STORAGE                       38
#DEFINE BD_NEW                           39
#DEFINE BD_SPLIT                         40

#DEFINE BD_FOUND                         50
#DEFINE BD_NOTFOUND                      51

#DEFINE BD_DISPLAY                       60
#DEFINE BD_VIEW                          61
#DEFINE BD_BROWSE                        62
#DEFINE BD_PROCESS                       63
#DEFINE BD_REFRESH                       64
#DEFINE BD_RETURN                        68

#DEFINE BD_START                         70
#DEFINE BD_STOP                          71
#DEFINE BD_OFF                           74
#DEFINE BD_ON                            75
#DEFINE BD_TEST_MODE                     78

#DEFINE BD_SAVE                          80
#DEFINE BD_SAVE_ADD                      81
#DEFINE BD_SAVE_EDIT                     82
#DEFINE BD_VALID                         83
#DEFINE BD_ABORT                         84
#DEFINE BD_COMPARE                       87

#DEFINE BD_COMM_OK                       90
#DEFINE BD_NO_COMM                       91
#DEFINE BD_TIMEOUT                       92

#DEFINE BD_SHOWTXT                      100
#DEFINE BD_SHOWVAR                      101
#DEFINE BD_SHOWNEW                      102

#DEFINE BD_SUM                          110
#DEFINE BD_ADJ                          111
#DEFINE BD_CRE                          112
#DEFINE BD_ZERO                         113
#DEFINE BD_NIL                          114
#DEFINE BD_LATE                         115

#DEFINE BD_LOCK                         120
#DEFINE BD_UNLOCK                       121

#DEFINE BD_TERMINATE                    150
#DEFINE BD_DEFAULT                      151
#DEFINE BD_VOID                         152
#DEFINE BD_EXPIRE                       153
#DEFINE BD_RENEW                        154
#DEFINE BD_SUSPEND                      155
#DEFINE BD_REANIMATE                    156
#DEFINE BD_GENERATE                     157
#DEFINE BD_TEST                         158

#DEFINE BD_CONNECT                      160
#DEFINE BD_NO_CONNECT                   161
#DEFINE BD_VALID_INTERNET               162
#DEFINE BD_NO_INTERNET                  163
#DEFINE BD_WEB_SITE_ERROR               164

#DEFINE BD_EXIT                         180
#DEFINE BD_TOGGLE                       185
#DEFINE BD_TAG                          186
#DEFINE BD_UNTAG                        187
#DEFINE BD_REVER                        188

#DEFINE BD_FIRST                        200
#DEFINE BD_NEXT                         201
#DEFINE BD_PREV                         202
#DEFINE BD_LAST                         203
#DEFINE BD_RIGHT                        204
#DEFINE BD_LEFT                         205
#DEFINE BD_UP                           206
#DEFINE BD_DOWN                         207
#DEFINE BD_BACK                         208
#DEFINE BD_FINISH                       209
#DEFINE BD_END                          210

#DEFINE BD_UPPER_LEFT                   250
#DEFINE BD_UPPER_RIGHT                  251
#DEFINE BD_LOWER_LEFT                   252
#DEFINE BD_LOWER_RIGHT                  253
#DEFINE BD_UPPER_CENTER                 254
#DEFINE BD_LOWER_CENTER                 255
#DEFINE BD_CENTER_LEFT                  256
#DEFINE BD_CENTER_RIGHT                 257

#DEFINE BD_REC_ADD                      300
#DEFINE BD_REC_LOCK                     301
#DEFINE BD_FILE_LOCK                    302

#DEFINE BD_ASSIGN                       400
#DEFINE BD_ASSIGN_NEW                   401
#DEFINE BD_UNASSIGN                     402
#DEFINE BD_UNASSIGN_MED                 403
#DEFINE BD_UNASSIGN_LEASE               404
#DEFINE BD_UNASSIGN_LEASE_AND_REASSIGN  404
#DEFINE BD_UNASSIGN_ALL                 405
#DEFINE BD_REASSIGN                     406
#DEFINE BD_TRANSFER                     407
#DEFINE BD_TRANSFER_LEASE               408
#DEFINE BD_REPLACE                      409
#DEFINE BD_BLANK                        410

#DEFINE BD_PRINT                        500
#DEFINE BD_FAX                          510

#DEFINE BD_BAD_DATA                     600
#DEFINE BD_BAD_DATA_TYPE                601

#DEFINE BD_AUTO                         700
#DEFINE BD_CHOOSE                       701
#DEFINE BD_CONFIRM                      702
#DEFINE BD_CONTINUE                     703
#DEFINE BD_OPTION                       704
#DEFINE BD_LOOP                         705

#DEFINE BD_LOGIN                        800
#DEFINE BD_LOGOUT                       801

#DEFINE BD_PRODUCTION                   900


/*-------------------------------------------------------------------
 define for bdms title bar icon
--------------------------------------------------------------------*/
*#DEFINE BMDS_APP_ICON  bdmsxp.ico

/*-------------------------------------------------------------------
 frame types for highlighted browse cells (XBP_PP_COL_DA_HILITEFRAMELAYOUT)
--------------------------------------------------------------------*/
#DEFINE BD_NOOUTLINE                0
#DEFINE BD_NOFRAME                  2
#DEFINE BD_THICK                  131
#DEFINE BD_THICK_RAISED            -1
#DEFINE BD_THICK_RECESSED          33
#DEFINE BD_VERYTHICK_RECESSED     163
#DEFINE BD_VERYTHICK_RAISED       503
#DEFINE BD_THICK_OUTLINE          129
#DEFINE BD_THIN_RAISED             -2 //17
#DEFINE BD_THIN_BLACK_RECESSED      1
#DEFINE BD_THIN_GREY_RECESSED      32
#DEFINE BD_VERYTHIN_RECESSED        3


/*-------------------------------------------------------------------
 frame combination types for XBP_PP_COL_DA_FRAMELAYOUT
 Before using the following Frame types, set
 {XBP_PP_COL_DA_CELLFRAMELAYOUT,BD_NORMAL_CELLFRAME}
 in the presentation arry
--------------------------------------------------------------------*/
#DEFINE BD_NOFRAMES                 2
#DEFINE BD_NORMAL_FRAME            16
#DEFINE BD_LATTICE_FRAME           -3
#DEFINE BD_THICK_GREY_FRAME         1
#DEFINE BD_THIN_FRAME              16
#DEFINE BD_THICK_BLACK_FRAME      140
#DEFINE BD_VERYTHICK_BLACK_FRAME   -1


/*-------------------------------------------------------------------
 cell frame combination types for XBP_PP_COL_DA_CELLFRAMELAYOUT
 Before using the following Frame types, set
 { XBP_PP_COL_DA_FRAMELAYOUT,BD_NORMALFRAME },;

 in the presentation arry
--------------------------------------------------------------------*/
#DEFINE BD_DOUBLE_CELLFRAME            3
#DEFINE BD_THICK_DOUBLE_CELLFRAME     -1
#DEFINE BD_RECESSED_DOUBLE_CELLFRAME  -2
#DEFINE BD_NORMAL_CELLFRAME            2



#DEFINE NOSEP_FLAT_NOHIGHLIGHT_CLEAR            0
#DEFINE NOSEP_RAISED_CELLHIGHLIGHT_VERYTHIN     16
#DEFINE NOSEP_RCCESSED_FRAMEHIGHLIGHT_THICK     32
#DEFINE NOSEP_OUTLINE_CELLHIGHLIGHT_THIN       129
#DEFINE NOSEP_RECCESSED_FRAMEHIGHLIGHT_THICK   164
#DEFINE NOSEP_RECCESSED_CELLHIGHLIGHT_THIN     165
#DEFINE NOSEP_RAISED_CELLHIGHLIGHT_THICK       176
#DEFINE NOSEP_RAISED_CELLHIGHLIGHT_THIN        177
#DEFINE NOSEP_FLAT_CELLHIGHLIGHT_THICK         192
#DEFINE NOSEP_FLAT_CELLHIGHLIGHT               193

/*-------------------------------------------------------------------
defines for use in XBP_PP_COL_HA_FRAMELAYOUT
 These will change the way the browse header looks
-------------------------------------------------------------------*/
#ifndef HDR_FLAT_NOFRAME_CLEAR

#DEFINE HDR_FLAT_NOFRAME_CLEAR                   0 /// no frame, no lines, no colors
#DEFINE HDR_FLAT_FRAME_CLEAR                     1 /// flat frame, separator lines, no color
#DEFINE HDR_FLAT_FRAME_HIGHLIGHT                 3 /// normal frame, separator lines, header colors
#DEFINE HDR_RAISED_FRAME_CLEAR                  16 /// raised clear frame, separator lines, no colors
#DEFINE HDR_RAISED_FRAME_CLEAR_THICK            17 /// raised frame, thick separator lines, no colors
#DEFINE HDR_RAISED_FRAME_HIGHLIGHT              18 /// raised frame, separator lines, header colors
#DEFINE HDR_EMBEDED_FRAME_HIGHLIGHT             19 /// normal frame, separator lines, header colors
#DEFINE HDR_EMBEDED_FRAME_HIGHLIGHT_THICK       23 /// normal frame, thick separator lines, header colors
#DEFINE HDR_RECESSED_FRAME_CLEAR                32 /// recessed clear frame, separator lines, no colors
#DEFINE HDR_RECESSED_FRAME_CLEAR_THICK          33 /// recessed clear frame, separator lines no colors
#DEFINE HDR_RECESSED_FRAME_HIGHLIGHT            34 /// recessed frame, separator lines, header colors
#DEFINE HDR_RECESSED_FRAME_HIGHLIGHT_THICK      35 /// recessed frame, thick separator lines, header colors
#DEFINE HDR_FLAT_FRAME_CLEAR_VERYTHICK         129 /// flat frame, very thick separator lines, no color
#DEFINE HDR_FLAT_FRAME_HIGHLIGHT_VERYTHICK     131 /// normal frame, very thick separator lines, header colors
#DEFINE HDR_EMBEDED_FRAME_HIGHLIGHT_VERYTHICK  147 /// normal frame, very thick separator lines, header colors
#DEFINE HDR_RECESSED_FRAME_CLEAR_VERYTHICK     161 /// recessed clear frame, very thick separator lines, no colors
#DEFINE HDR_RECESSED_FRAME_HIGHLIGHT_VERYTHICK 163 /// recessed frame, very thick separator lines, header colors
#DEFINE HDR_RAISED_FRAME_CLEAR_VERYTHICK       177 /// raised frame, very thick separator lines, no colors
#DEFINE HDR_RAISED_FRAME_HIGHLIGHT_VERYTHICK   179 /// raised frame, very thick separator lines, header colors

#endif

/*-------------------------------------------------------------------
 generic defines for cursor shapes
--------------------------------------------------------------------*/
#DEFINE CURSOR_4WAY         4
#DEFINE CURSOR_CROSSHAIR    5
#DEFINE CURSOR_DIAGLEFT     6
#DEFINE CURSOR_DIAGRIGHT    7
#DEFINE CURSOR_LEFTRIGHT    8
#DEFINE CURSOR_UPDOWN       9
#DEFINE CURSOR_NORMAL       10
#DEFINE CURSOR_INFO         11
#DEFINE CURSOR_QUESTION     12
#DEFINE CURSOR_CANCEL       13
#DEFINE CURSOR_NOTICE       14
#DEFINE CURSOR_VIEW         19


// -------------------------------------------------------------------
//  defines for FORM_BOX
// --------------------------------------------------------------------
#DEFINE FORM_RIGHT        XBPSTATIC_TEXT_RIGHT
#DEFINE FORM_LEFT         XBPSTATIC_TEXT_LEFT
#DEFINE FORM_RIGHTBOTTOM  XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_BOTTOM
#DEFINE FORM_LEFTBOTTOM   XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_BOTTOM
#DEFINE FORM_CENTERBOTTOM XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_BOTTOM
#DEFINE FORM_RIGHTCENTER  XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_VCENTER
#DEFINE FORM_LEFTCENTER   XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER
#DEFINE FORM_RIGHTTOP     XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_TOP
#DEFINE FORM_LEFTTOP      XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_TOP
#DEFINE FORM_CENTER       XBPSTATIC_TEXT_CENTER
#DEFINE FORM_HCENTER      XBPSTATIC_TEXT_CENTER
#DEFINE FORM_BOTTOM       XBPSTATIC_TEXT_BOTTOM
#DEFINE FORM_BOTTOMLEFT   XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_BOTTOM
#DEFINE FORM_BOTTOMRIGHT  XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_BOTTOM
#DEFINE FORM_TOP          XBPSTATIC_TEXT_TOP
#DEFINE FORM_TOPCENTER    XBPSTATIC_TEXT_TOP + XBPSTATIC_TEXT_CENTER
#DEFINE FORM_VCENTER      XBPSTATIC_TEXT_VCENTER
#DEFINE FORM_HVCENTER     XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER
#DEFINE FORM_WORDBREAK    XBPSTATIC_TEXT_WORDBREAK
// -------------------------------------------------------------------
//  end defines for FORM_BOX
// --------------------------------------------------------------------

// --------------------------------------------------------------------
// define for DC_SAY/GET wordbreak
#DEFINE WORDBREAKRIGHT  SAYOPTION XBPSTATIC_TEXT_WORDBREAK+XBPSTATIC_TEXT_RIGHT
// --------------------------------------------------------------------


/// ------------------------------------------------------------------------
///  Define for environmental variables
/// ------------------------------------------------------------------------
#DEFINE APP_SYS_ENV_NAME              '_SYSTEM_PATH'                 /// the name of the environment string containing the system path
/// ------------------------------------------------------------------------


/// ------------------------------------------------------------------------
///  begin defines for file names
/// ------------------------------------------------------------------------
#DEFINE RESOLUTION_FILE               "_mlres.txt"                   /// contains forced resolution settings 800X??? 1280X1024 1440X1024 or greater than 1024
/// ------------------------------------------------------------------------
///  end begin defines for file names
/// ------------------------------------------------------------------------





// ------------------------------------------------------------------------
//  Define for control line feed
// ------------------------------------------------------------------------
#DEFINE CR_LF    Chr(13)+Chr(10)
#DEFINE CR_      Chr(13)
#DEFINE _LF      Chr(10)
// ------------------------------------------------------------------------

// ------------------------------------------------------------------------
//  define to determine if tab page is active
// ------------------------------------------------------------------------
#DEFINE ACTIVE_TAB(oTab)  !oTab:minimized
// ------------------------------------------------------------------------


// ------------------------------------------------------------------------
//  define to determine browse column heading
// ------------------------------------------------------------------------
#DEFINE BROWSE_HEADING(oBrowse)  oBrowse:getColumn(oBrowse:colPos):heading:cargo
// ------------------------------------------------------------------------


// ------------------------------------------------------------------------
//  define to calculate percentage
// ------------------------------------------------------------------------
#DEFINE CALC_PCT(nAmt, nPct) ABS((ABS(nPct)/100) * nAmt)
// ------------------------------------------------------------------------



/*-------------------------------------------------------------------
 define to stop playing a wave file
--------------------------------------------------------------------*/
#DEFINE STOP_WAVE() DllCall("WINMM.DLL",32,"PlaySoundA", '__$xyz__', 0, 131072 + 0x0004)
/*-------------------------------------------------------------------
 end define to stop playing a wave file
--------------------------------------------------------------------*/


/*-------------------------------------------------------------------
 generic defines for key combinations not covered in alaska's appevent.ch
--------------------------------------------------------------------*/
#DEFINE K_ALT_CTRL_H     852020
#DEFINE K_ALT_CTRL_L     852044
#DEFINE K_ALT_CTRL_C     852035
#DEFINE K_ALT_CTRL_Q     852049
/*-------------------------------------------------------------------
 end generic defines for key combinations not covered in alaska's appevent.ch
--------------------------------------------------------------------*/


/*-------------------------------------------------------------------
 defines For column and row text numbers to col and row pixels
--------------------------------------------------------------------*/
#XTRANSLATE ROW2PIX(<n>) => (<n>*19.7142857143)
#XTRANSLATE COL2PIX(<n>) => (<n>*11.0)
#DEFINE ROW_TO_PIXEL 19.7142857143
#DEFINE COL_TO_PIXEL 11.0
/*-------------------------------------------------------------------
 end defines For column and row text numbers to col and row pixels
--------------------------------------------------------------------*/

/*-------------------------------------------------------------------
 defines for file movement
--------------------------------------------------------------------*/

#DEFINE F_GOEND( nFile ) FSeek( nFile, 0 , FS_END )


/*-------------------------------------------------------------------
 general defines when using codeblocks
--------------------------------------------------------------------*/
#DEFINE _TRUE     {|| .T. }
#DEFINE _FALSE    {|| .F. }
#DEFINE _NIL      {|| nil }

/*-------------------------------------------------------------------
 null bypass for SQL useage
--------------------------------------------------------------------*/
 #DEFINE NULLC(cVar)      isNull(cVar, "")
 #DEFINE NULLD(cVar)      isNull(cVar, CTOD(""))
 #DEFINE NULLN(cVar)      isNull(cVar, 0 )
 #DEFINE NULLL(cVar)      isNull(cVar, .F. )


/*-------------------------------------------------------------------
 defines for the Fmt_Name() function
--------------------------------------------------------------------*/
#DEFINE FN_ARRAY                         0
#DEFINE FN_FIRST_LAST                    1
#DEFINE FN_LAST_FIRST                    2
#DEFINE FN_FIRST_MID_LAST                3
#DEFINE FN_FIRST_MI_LAST                 4
#DEFINE FN_LAST_FIRST_MI                 5
#DEFINE FN_LAST_FIRST_MID                6
#DEFINE FN_FI_LAST                       7
#DEFINE FN_FI_MI_LAST                    8
#DEFINE FN_SAL_FIRST_LAST                9
#DEFINE FN_SAL_FIRST_MID_LAST           10
#DEFINE FN_SAL_FIRST_MI_LAST            11
#DEFINE FN_SAL_FI_LAST                  12
#DEFINE FN_SAL_FI_MI_LAST               13
#DEFINE FN_SAL_LAST                     14
/*-------------------------------------------------------------------
 end defines for the Fmt_Name() function
--------------------------------------------------------------------*/

/*-------------------------------------------------------------------
 defines for BDMS mail settings dat file
--------------------------------------------------------------------*/
#DEFINE BDMSMAIL_SUPPORT       1
#DEFINE BDMSMAIL_SALES         2
#DEFINE BDMSMAIL_TECHNICAL     1
#DEFINE BDMSMAIL_SERVICES      1
#DEFINE BDMSMAIL_GENERAL       2

#DEFINE BDMSMAIL_SENDER        1
#DEFINE BDMSMAIL_USER          2
#DEFINE BDMSMAIL_PASSWORD      3
#DEFINE BDMSMAIL_SERVER        4
#DEFINE BDMSMAIL_PORT          5
#DEFINE BDMSMAIL_CC            6

#DEFINE SMTP_SERVICES          1
#DEFINE SMTP_SUPPORT           2
#DEFINE SMTP_CUSTOMERSERVICE   3
#DEFINE SMTP_GENERAL           4

#DEFINE SMTP_SETTINGS_FILE           "smtp.dat"            /// contains all SMTP MAIL SETTINGS / use SmtpSettings.Exe
#DEFINE SMTP_DEFAULT_SETTINGS_FILE   "smtpdefault.dat"     /// contains the default SMTP MAILL SETTINGS (Used for Tracker email)
#DEFINE SMTP_DEFAULT_VALUES_FILE     "smtpdefault.txt"     /// text file containing DEFAULT SMTP MAIL SETTINGS (Used for reference & kept in development directory only)

/*-------------------------------------------------------------------
 end defines for BDMS mail settings dat file
--------------------------------------------------------------------*/


/// -------------------------------------------------------------------------
///  defines for WhoisLoggedOn() in BdUser.prg
/// -------------------------------------------------------------------------
#DEFINE WHOIS_LOGGED_ID       1
#DEFINE WHOIS_LOGGED_USER     2
#DEFINE WHOIS_LOGGED_OFFICE   3
/// -------------------------------------------------------------------------
///  end defines for WhoisLoggedOn() in BdUser.prg
/// -------------------------------------------------------------------------


/// -------------------------------------------------------------------------
/// wave defines
/// -------------------------------------------------------------------------
#DEFINE W_ABORTANDRETRY          1
#DEFINE W_ADDCOMPLETE            2
#DEFINE W_ADDALERT               3
#DEFINE W_ADDERROR               4
#DEFINE W_ALERTSOFT              5
#DEFINE W_ALERTMEDIUM            6
#DEFINE W_ALERTLOUD              7
#DEFINE W_ANNOUNCE               8
#DEFINE W_ARCHIVEALERT           9
#DEFINE W_ARCHIVEDONE           10
#DEFINE W_AUTHREQUIRED          11
#DEFINE W_BADNEWS               12
#DEFINE W_BOF                   13
#DEFINE W_BUZZ                  14
#DEFINE W_BUZZER                15
#DEFINE W_BUZZERSOFT            16
#DEFINE W_CANTDOALERT           17
#DEFINE W_CANTDOTHAT            18
#DEFINE W_CODESAREVOID          19
#DEFINE W_CODESVERIFIED         20
#DEFINE W_COMMDIAL              21
#DEFINE W_COMMDIALCONNECT       22
#DEFINE W_COMMCONNECTLONG       23
#DEFINE W_COMMCONNECTLOWLONG    24
#DEFINE W_COMMCONNECTSHORT      25
#DEFINE W_COMMCLOSED            26
#DEFINE W_COMMHANGUP            27
#DEFINE W_COMMRING              28
#DEFINE W_COMMVERIFIED          29
#DEFINE W_CONFIRMED             30
#DEFINE W_CUT                   31
#DEFINE W_DBERROR               32
#DEFINE W_DBOPENERROR           33
#DEFINE W_DELETEQUESTION        34
#DEFINE W_DELETED               35
#DEFINE W_DELETEALERT           36
#DEFINE W_DIALTONELONG          37
#DEFINE W_DIALTONESHORT         38
#DEFINE W_DONTPLAYGAMES         39
#DEFINE W_DONTSAVE              40
#DEFINE W_DUPALERT              41
#DEFINE W_EOF                   42
#DEFINE W_ERROR                 43
#DEFINE W_FACINATING            44
#DEFINE W_FAILURE               45
#DEFINE W_FAILUREALERT          46
#DEFINE W_FANFARE               47
#DEFINE W_FORGOTTOTELL          48
#DEFINE W_FUNCTIONCOMPLETE      49
#DEFINE W_GOBACK                50
#DEFINE W_GOTIT                 51
#DEFINE W_GOTMAIL               52
#DEFINE W_HEADSUP               53
#DEFINE W_INCORRECTCODE         54
#DEFINE W_INSANE                55
#DEFINE W_INVALID               56
#DEFINE W_MODIFICATIONCOMPLETE  57
#DEFINE W_MULTICUT              58
#DEFINE W_MULTIPOP              59
#DEFINE W_NOTIFY                60
#DEFINE W_OK                    61
#DEFINE W_OOPS                  62
#DEFINE W_OPENDRAWER            63
#DEFINE W_PAPERTURN             64
#DEFINE W_PARDON                65
#DEFINE W_PAYATTENTION          66
#DEFINE W_PLEASESPECIFY         67
#DEFINE W_POP                   68
#DEFINE W_QUESTION              69
#DEFINE W_QUICKQUESTION         70
#DEFINE W_RECORDNOTFOUND        71
#DEFINE W_REMOVED               72
#DEFINE W_SPECIFIC              73
#DEFINE W_SAVE                  74
#DEFINE W_SOAPCONNECT           75
#DEFINE W_SOMETHING             76
#DEFINE W_SUBTLESAVE            77
#DEFINE W_SWOOP                 78
#DEFINE W_TERMINATE             79
#DEFINE W_THEME                 80
#DEFINE W_THUD                  81
#DEFINE W_TICK                  82
#DEFINE W_TRASH                 83
#DEFINE W_UHOH                  84
#DEFINE W_UNABLETOCOMPLY        85
#DEFINE W_UNDO                  86
#DEFINE W_UPDATE                87
#DEFINE W_UNUSUAL               88
#DEFINE W_WAKEUP                89
#DEFINE W_WHATAREYOUDOING       90
/// -------------------------------------------------------------------------
/// end wave defines
/// -------------------------------------------------------------------------


*#command  TEXT INTO <varname> WRAP
*      =>  text literal, <varname>, CHR(13)+CHR(10)


#command  TEXT INTO <varname> WRAP <lnbreak> TRIMMED ;
      =>  text literal, <varname>, <lnbreak>, ltrim


#command  TEXT INTO <varname> WRAP TRIMMED
      =>  text literal, <varname>, CHR(13)+CHR(10), ltrim



#translate _IF <exp>  <IFclauses,...>  _ELSE <ELSEclauses,...> _ENDIF => ;
           IIF( <exp>,(<IFclauses>),(<ELSEclauses>) )

#translate _IF <exp>  <IFclauses,...> _ENDIF  => IIF( <exp>,(<IFclauses>), nil )


#xtranslate Push_Db()                          =>   Db_Push()
#xtranslate Push_Db( [<cAlias>] )              =>   Db_Push( <cAlias> )
#xtranslate Push_Db( [<cAlias>], [<nOrder>] )  =>   Db_Push( <cAlias>, <nOrder> )
#xtranslate Pop_Db( <aStack> )                 =>   Db_Pop( <aStack> )

#translate MinMaxOk( <xVal>, <xMinVal>, <xMaxVal> ) ;
         => ( <xVal> >= <xMinVal> .AND. <xMaxVal> >= <xVal> )

#translate MinMax( <xVal>, <xMinVal>, <xMaxVal> ) ;
         => ( Max(<xMinVal>, Min( <xVal>, <xMaxVal> )) )



//----------------------------03-07-94 00:12am-----------------------------
//-        Translate Directives For B. D. M. S. Library Routines
//-------------------------------------------------------------------------

//
// ADD_REC
//
#xtranslate Add_Rec( [ ALIAS        <cAlias>     [,] ] ;
                     [ BLOCK        <bBlock>     [,] ] ;
                     [ TIMEOUT      <nTimeOut>   [,] ] ;
                     [ WAVE         <cWave>      [,] ] ;
                    )                                 ;
=> ;
Add_Rec( <cAlias>, <bBlock>, <nTimeOut>, <cWave> )

//
// ADD_REC
//
#command Add_Rec [TO <lSucess>  ] ;
                 [ALIAS <cAlias> ] ;
                 [BLOCK <bBlock> ] ;
                 [TIMEOUT <nTimeOut> ] ;
                 [WAVE <cWave> ] ;
                                                 ;
=> ;
<lSucess> := Add_Rec( <cAlias>, <bBlock>, <nTimeOut>, <cWave> )


//
//  ALERT_MSG
//
#xtranslate Alert_Msg(  TEXT        <cText>        [,]   ;
                      [ BUTTONS     <aButtons>     [,] ] ;
                      [ TITLE       <cTitle>       [,] ] ;
                      [ WAVE        <cWave>        [,] ] ;
                      [ ICON        <nIcon>        [,] ] ;
                      [ FONT        <cFont>        [,] ] ;
                      [ FGCOLOR     <cFgColor>     [,] ] ;
                      [ BGCOLOR     <cBgColor>     [,] ] ;
                      [ OWNER       <oOwner>       [,] ] ;
                      [ TIMEOUT     <nTimeOut>     [,] ] ;
                      [ COORDS      <aCoords>      [,] ] ;
                      [ ALIGN       <aAlign>       [,] ] ;
                      [ ONTOP       <lOnTop>       [,] ] ;
                     )                                   ;
=> ;
Alert_Msg( <cText>, <aButtons>, <cTitle>, <cWave>, <nIcon>, <cFont>, <cFgColor>, <cBgColor>, <oOwner>, <nTimeOut>, <aCoords>, <aAlign>, <lOnTop> )



///  ALERT_WIN

*#xtranslate Alert_Win(  TEXT        <cText>        [,]   ;
*                      [ BUTTONS     <aButtons>     [,] ] ;
*                      [ TITLE       <cTitle>       [,] ] ;
*                      [ WAVE        <cWave>        [,] ] ;
*                      [ FOCUS       <nFocus>       [,] ] ;
*                      [ ICON        <nIcon>        [,] ] ;
*                      [ CHECK       <lCheck>       [,] ] ;
*                      [ PROMPT      <cCheckPrompt> [,] ] ;
*                      [ EDITPROTECT <lEditProtect> [,] ] ;
*                      [ FONT        <cFont>        [,] ] ;
*                      [ FGCOLOR     <cFgColor>     [,] ] ;
*                      [ BGCOLOR     <cBgColor>     [,] ] ;
*                      [ OWNER       <oOwner>       [,] ] ;
*                      [ TIMEOUT     <nTimeOut>     [,] ] ;
*                      [ COORDS      <aCoords>      [,] ] ;
*                      [ ALIGN       <aAlign>       [,] ] ;
*                      [ ONTOP       <lOnTop>       [,] ] ;
*                     )                                   ;
*=> ;
*Alert_Win( <cText>, <aButtons>, <cTitle>, <cWave>, <nFocus>, <nIcon>, <lCheck>, <cCheckPrompt>, <lEditProtect>, ;
*           <cFont>, <cFgColor>, <cBgColor>, <oOwner>, <nTimeOut>, <aCoords>, <aAlign>, <lOnTop> )

#xtranslate Alert_Win(  TEXT        <cText>        [,]   ;
                      [ BUTTONS     <aButtons>     [,] ] ;
                      [ TITLE       <cTitle>       [,] ] ;
                      [ WAVE        <cWave>        [,] ] ;
                      [ FOCUS       <nFocus>       [,] ] ;
                      [ ICON        <nIcon>        [,] ] ;
                      [ CHECK       <lCheck>       [,] ] ;
                      [ PROMPT      <cCheckPrompt> [,] ] ;
                      [ EDITPROTECT <lEditProtect> [,] ] ;
                      [ FONT        <cFont>        [,] ] ;
                      [ FGCOLOR     <cFgColor>     [,] ] ;
                      [ BGCOLOR     <cBgColor>     [,] ] ;
                      [ OWNER       <oOwner>       [,] ] ;
                      [ TIMEOUT     <nTimeOut>     [,] ] ;
                      [ COORDS      <aCoords>      [,] ] ;
                      [ ALIGN       <aAlign>       [,] ] ;
                      [ ALIGNTEXT   <nAlignText>   [,] ] ;
                      [ ONTOP       <lOnTop>       [,] ] ;
                      [ MODAL       <lModal>       [,] ] ;
                      [<lMoveCursor:MOVECURSOR>        ] ;
                      [_MOVECURSOR <_lMoveCursor>      ] ;
                     ) ;
=> ;
Alert_Win( <cText>, <aButtons>, <cTitle>, <cWave>, <nFocus>, <nIcon>, <lCheck>, <cCheckPrompt>, <lEditProtect>, ;
           <cFont>, <cFgColor>, <cBgColor>, <oOwner>, <nTimeOut>, <aCoords>, <aAlign>, <lOnTop>, <lModal>, ;
           <.lMoveCursor.> [.OR. <_lMoveCursor>], <nAlignText> )


///  ALERTWIN

// *#xtranslate ALERTWIN [TO           <nVal> ] ;
// *                      TEXT         <cText> ;
// *                     [BUTTONS      <aButtons> ] ;
// *                     [TITLE        <cTitle> ] ;
// *                     [WAVE         <cWave> ] ;
// *                     [FOCUS        <nFocus> ] ;
// *                     [ICON         <nIcon> ] ;
// *                     [CHECK        <lCheck> ] ;
// *                     [PROMPT       <cCheckPrompt> ] ;
// *                     [EDITPROTECT  <lEditProtect> ] ;
// *                     [FONT         <cFont> ] ;
// *                     [FGCOLOR      <cFgColor> ] ;
// *                     [BGCOLOR      <cBgColor> ] ;
// *                     [OWNER        <oOwner> ] ;
// *                     [TIMEOUT      <nTimeOut> ] ;
// *                     [COORDS       <aCoords> ] ;
// *                     [ALIGN        <aAlign> ] ;
// *                     [ONTOP        <lOnTop> ] ;
// *=> ;
// *<nVal> := Alert_Win( <cText>, <aButtons>, <cTitle>, <cWave>, <nFocus>, <nIcon>, <lCheck>, <cCheckPrompt>, ;
// *                     <lEditProtect>, <cFont>, <cFgColor>, <cBgColor>, <oOwner>, <nTimeOut>, <aCoords>, <aAlign>, <lOnTop> )

#translate ALERTWIN [TO <nVal>] ;
                     TEXT        <cText> ;
                    [BUTTONS     <aButtons>] ;
                    [TITLE       <cTitle>] ;
                    [WAVE        <cWave>] ;
                    [FOCUS       <nFocus>] ;
                    [ICON        <nIcon>] ;
                    [CHECK       <lCheck>] ;
                    [PROMPT      <cCheckPrompt>] ;
                    [EDITPROTECT <lEditProtect>] ;
                    [FONT        <cFont>] ;
                    [FGCOLOR     <cFgColor>] ;
                    [BGCOLOR     <cBgColor>] ;
                    [OWNER       <oOwner>] ;
                    [TIMEOUT     <nTimeOut>] ;
                    [COORDS      <aCoords>] ;
                    [ALIGN       <aAlign>] ;
                    [ONTOP       <lOnTop>], ;
                    [MODAL       <lModal>] ;
                    [<lMoveCursor:MOVECURSOR>] ;
                    [_MOVECURSOR <_lMoveCursor>] ;
=> ;
<nVal> := Alert_Win( <cText>, <aButtons>, <cTitle>, <cWave>, <nFocus>, <nIcon>, <lCheck>, <cCheckPrompt>, ;
                     <lEditProtect>, <cFont>, <cFgColor>, <cBgColor>, <oOwner>, <nTimeOut>, <aCoords>, <aAlign>, <lOnTop>, <lModal>, <.lMoveCursor.> [.OR. <_lMoveCursor>] )



///  ALERTWIN

#xtranslate ALERTOK TEXT         <cText> ;
                    [BUTTONS      <aButtons> ] ;
                    [TITLE        <cTitle> ] ;
                    [WAVE         <cWave> ] ;
                    [FOCUS        <nFocus> ] ;
                    [ICON         <nIcon> ] ;
                    [CHECK        <lCheck> ] ;
                    [PROMPT       <cCheckPrompt> ] ;
                    [EDITPROTECT  <lEditProtect> ] ;
                    [FONT         <cFont> ] ;
                    [FGCOLOR      <cFgColor> ] ;
                    [BGCOLOR      <cBgColor> ] ;
                    [OWNER        <oOwner> ] ;
                    [TIMEOUT      <nTimeOut> ] ;
                    [COORDS       <aCoords> ] ;
                    [ALIGN        <aAlign> ] ;
                    [ONTOP        <lOnTop> ] ;
=> ;
Alert_Win( <cText>, <aButtons>, <cTitle>, <cWave>, <nFocus>, <nIcon>, <lCheck>, <cCheckPrompt>, ;
           <lEditProtect>, <cFont>, <cFgColor>, <cBgColor>, <oOwner>, <nTimeOut>, <aCoords>, <aAlign>, <lOnTop> )



//
// CHECKBOX
//
#command @ <nRow>, <nCol> CHECKBOX [<cVal>] ;
           [PROMPT      <cPrompt>] ;
           [PARENT      <oParent>] ;
           [YESVAL      <cYesVal>] ;
           [NOVAL       <cNoVal>] ;
           [COLOR       <nFgC> [,<nBgC>] ] ;
           [FONT        <cFont>] ;
           [SIZE        <nWidth> [,<nHeight>] ] ;
           [ID          <cId>] ;
           [GROUP       <cGroup>] ;
           [PRES        <aPres>] ;
           [SAYPOS      <nSayRow>,<nSayCol>] ;
           [OBJECT      <oChkMark>] ;
           [ACTION      <bAction>] ;
           [DATALINK    <bDataLink>] ;
           [GOTFOCUS    <bGotFocus>] ;
           [LOSTFOCUS   <bLostFocus>] ;
           [EDITPROTECT <bEditProtect>] ;
           [HIDE        <bHide>] ;
           [WHEN        <bWhen>] ;
           [VALID       <bValid>] ;
           [ACCELKEY    <anAccelKey>] ;
           [TOOLTIP     <cToolTip>] ;
  => ;
  Check_Box( @<cVal>, <cPrompt>, <cYesVal>, <cNoVal>, @GetList, [@<oParent>], [@<oChkMark>],;
             <nRow>, <nCol>, <cFont>, <nFgC>, <nBgC>, <nWidth>, <nHeight>, <cId>, <cGroup>, <aPres>,;
             <nSayRow>, <nSayCol>, <bAction>, <bDataLink>, <bGotFocus>, <bLostFocus>, ;
             <bEditProtect>, <bHide>, <bWhen>, <bValid>, <anAccelKey>, <cToolTip> )

//
// DATE_WIN
//
#xtranslate Date_Win   DATE       <aDate>                ;
                     [ TITLE      <cTitle>         [,] ] ;
                     [ OPTION     <nOpt>           [,] ] ;
                     [ TEXT       <cText>          [,] ] ;
                     [ SAY        <cSay>           [,] ] ;
                     [ BUTTONS    <lButtons>       [,] ] ;
                     [ WAVE       <cWave>          [,] ] ;
                     [ FONT       <cFont>          [,] ] ;
                     [ FGCOLOR    <cFgColor>       [,] ] ;
                     [ BGCOLOR    <cBgColor>           ] ;
                                                         ;
=> ;
Date_Win( <aDate>, <cTitle>, <nOpt>, <cText>, <cSay>, ;
          <lButtons>, <cWave>, <cFont>, <cFgColor>, <cBgColor>)


//
// FILE_LOCK
//
#xtranslate File_Lock( [ ALIAS        <cAlias>     [,] ] ;
                       [ TIMEOUT      <nTimeOut>   [,] ] ;
                       [ WAVE         <cWave>      [,] ] ;
                      )                                  ;
=> ;
File_Lock( <cAlias>, <nTimeOut>, <cWave> )


//
// FILE_LOCKS
//
#xtranslate File_Locks( [ ALIAS        <acAlias>    [,] ] ;
                        [ TIMEOUT      <nTimeOut>   [,] ] ;
                        [ WAVE         <cWave>      [,] ] ;
                        [ RETRY        <lRetry>     [,] ] ;
                       )                                  ;
=> ;
File_Locks( <acAlias>, <nTimeOut>, <cWave>, <lRetry> )




//
// FILE_MATCH
//
#xtranslate Find_Match( [ ALIAS      <cAlias>     [,] ] ;
                        [ ORDER      <nOrd>       [,] ] ;
                        [ WHILE      <bWhile>     [,] ] ;
                        [ FOR        <bFor>       [,] ] ;
                        [ BROWSE     <aBrow>      [,] ] ;
                        [ SEEK       <xSeek>      [,] ] ;
                        [ REVERSE    <lReverse>       ] ;
                      )                                 ;
=> ;
Find_Match( <cAlias>, <nOrd>, <bWhile>, <bFor>, <aBrow>, <xSeek>, <lReverse>)


//
// F_RENAME
//
#command F_Rename [ TO         <lVal> ] ;
                    OLDFILE    <cOldFile> ;
                    NEWFILE    <cNewFile> ;
                  [ TEXT       <cText> ] ;
                  [ WAVE       <cWave> ] ;
=> ;
<lVal> := F_Rename( <cOldFile>, <cNewFile>, <cText>, <cWave> )


//
// F_RENAME
//
#xtranslate F_Rename(  OLDFILE  <cOldFile>           [,] ] ;
                       NEWFILE  <cNewFile>           [,] ] ;
                     [ TEXT     <cText>              [,] ] ;
                     [ WAVE     <cWave>              [,] ] ;
                                                           ;
=> ;
F_Rename( <cOldFile>, <cNewFile>, <cText>, <cWave> )



//
// GET_DATES
//
#command Get_Dates [ TO         <lVal> ] ;
                     BEGIN      <dBgn> ;
                     END        <dEnd> ;
                   [ TEXT       <cText> ] ;
                   [ SELECT     <nSelect> ] ;
                   [ AUTODATES  <aAutoDates> ] ;
=> ;
<lVal> := Get_Dates( <dBgn>, <dEnd>, <cText>, <nSelect>, <aAutoDates>)





// G E T M E M O

#command @ <nRow>, <nCol> GETMEMO ;
           [MEMO            <cMemo>]               ;
           [CAPTION         <cCaption>]            ;
           [TITLE           <clTitle>]             ;
           [SIZE            <nWidth> [,<nHeight>]] ;
           [GETOBJECT       <oGet>]                ;
           [FONT            <cFont>]               ;
           [TIMESTAMP       <clTimeStamp>]         ;
           [PARENT          <oParent>]             ;
           [COLOR           <ncFgC> [,<ncBgC>]]    ;
           [OBJECT          <oObject>]             ;
           [EDITPROTECT     <bEdit>]               ;
           [WHEN            <bWhen>]               ;
           [VALID           <bValid>]             ;
           [TOOLTIP         <cToolTip>]            ;
 => ;
 Get_Memo( @<cMemo>, <cCaption>, <clTitle>, <nWidth>, <nHeight>, <oGet>, <cFont>, ;
           <clTimeStamp>, <oParent>, <nRow>, <nCol>, <ncFgC>, <ncBgC>, <oObject>, ;
           <bEdit>, <bWhen>, <bValid>, <cToolTip> )


// G E T _ M E M O

#command Get_Memo( ;
                  [MEMO            <cMemo>]               ;
                  [CAPTION         <cCaption>]            ;
                  [TITLE           <clTitle>]             ;
                  [SIZE            <nWidth> [,<nHeight>]] ;
                  [GETOBJECT       <oGet>]                ;
                  [FONT            <cFont>]               ;
                  [TIMESTAMP       <lTimeStamp>]          ;
                  [PARENT          <oParent>]             ;
                  [COORDS          <nRow> [,<nCol>]]      ;
                  [COLOR           <ncFgC> [,<ncBgC>]]    ;
                  [OBJECT          <oObject>]             ;
                  [EDITPROTECT     <bEdit>]               ;
                  [WHEN            <bWhen>]               ;
                  [VALID           <bValid>]              ;
                  [TOOLTIP         <cToolTip>])           ;
 => ;
 Get_Memo( @<cMemo>, <cCaption>, <clTitle>, <nWidth>, <nHeight>, <oGet>, <cFont>, ;
            <lTimeStamp>, <oParent>, <nRow>, <nCol>, <ncFgC>, <ncBgC>, <oObject>, ;
            <bEdit>, <bWhen>, <bValid>, <cToolTip> )

/// A D D _ T O M E M O

#command @ <nRow>, <nCol> ADDTOMEMO ;
           TO               <lAdded>               ;
           [MEMOSTR         <cMemo>]               ;
           [TITLE           <cTitle>]              ;
           [TIMESTAMP       <clTimeStamp>]         ;
           [PARENT          <oParent>]             ;
           [LEFTSIDE        <aMemoProp1>]          ;
           [RIGHTSIDE       <aMemoProp2>]          ;
           [SIDEBYSIDE      <lSideBySide>]         ;
 => ;
 <lAdded> := Add_ToMemo( <cMemo>, <cTitle>, <clTimeStamp>, <oParent>, <aMemoProp1>, <aMemoProp2>, <nRow>, <nCol>, <lSideBySide> )


/// A D D _ T O M E M O

#xtranslate Add_ToMemo(  MEMOSTR    <cMemo>             [,] ] ;
                       [ TITLE      <cTitle>            [,] ] ;
                       [ TIMESTAMP  <clTimeStamp>       [,] ] ;
                       [ TITLE      <cTitle>            [,] ] ;
                       [ PARENT     <oParent>           [,] ] ;
                       [ LEFTSIDE   <aMemoProp1>        [,] ] ;
                       [ RIGFHTSIDE <aMemoProp2>        [,] ] ;
                       [COORDS      <nRow> [,<nCol>]    [,] ] ;
                       [SIDEBYSIDE  <lSideBySide> ])          ;
=> ;
 Add_ToMemo( @<cMemo>, <cTitle>, <clTimeStamp>, <oParent>, <aMemoProp1>, <aMemoProp2>, <nRow>, <nCol>, <lSideBySide> )




//
// GET_WIN
//
#command GETWIN  [ TO         <lVal> ] ;
                   GET        <uGet> ;
                 [ SAY        <cSay> ] ;
                 [ PICTURE    <cPic> ] ;
                 [ TITLE      <cTitle> ] ;
                 [ BUTTONS    <lButtons> ] ;
                 [ WAVE       <cWave> ] ;
                 [ TEXT       <cText> ] ;
                 [ GETSIZE    <nGetSize> ] ;
                 [ SAYSIZE    <nSaySize> ] ;
                 [ FONT       <cFont> ] ;
                 [ FGCOLOR    <cFgColor> ] ;
                 [ BGCOLOR    <cBgColor> ] ;
                 [ PARENT     <oParent> ] ;
                 [ UNREADABLE <lUnreadable> ] ;
                 [ PROPER     <lProper> ] ;
                 [ POPUP      <bPopUp> ] ;
                 [ POPCAPTION <cPopCaption> ] ;
                 [ POPFONT    <cPopFont> ] ;
                 [ OBJECT     <oGet> ] ;
                 [ TIMEOUT    <nTimeOut> ] ;
=> ;
<lVal> := Get_Win( <uGet>, <cSay>, <cPic>, <cTitle>, <lButtons>, <cWave>, <cText>, <nGetSize>, <nSaySize>, <cFont>, ;
                   <cFgColor>, <cBgColor>, <oParent>, <lUnreadable>, <lProper>, <bPopUp>, <cPopCaption>, <cPopFont>, <oGet>, <nTimeOut>)


//
// GET_WIN
//
#xtranslate Get_Win(  GET        <uGet>           [,] ] ;
                    [ SAY        <cSay>           [,] ] ;
                    [ PICTURE    <cPic>           [,] ] ;
                    [ TITLE      <cTitle>         [,] ] ;
                    [ BUTTONS    <lButtons>       [,] ] ;
                    [ WAVE       <cWave>          [,] ] ;
                    [ TEXT       <cText>          [,] ] ;
                    [ GETSIZE    <nGetSize>       [,] ] ;
                    [ SAYSIZE    <nSaySize>       [,] ] ;
                    [ FONT       <cFont>          [,] ] ;
                    [ FGCOLOR    <cFgColor>       [,] ] ;
                    [ BGCOLOR    <cBgColor>       [,] ] ;
                    [ PARENT     <oParent>        [,] ] ;
                    [ UNREADABLE <lUnreadable>    [,] ] ;
                    [ PROPER     <lProper>        [,] ] ;
                    [ POPUP      <bPopUp>         [,] ] ;
                    [ POPCAPTION <cPopCaption>    [,] ] ;
                    [ POPFONT    <cPopFont>       [,] ] ;
                    [ OBJECT     <oGet>           [,] ] ;
                    [ TIMEOUT    <nTimeOut>           ]) ;
                                                        ;
=> ;
Get_Win( <uGet>, <cSay>, <cPic>, <cTitle>, <lButtons>, <cWave>, <cText>, <nGetSize>, <nSaySize>, <cFont>,;
         <cFgColor>, <cBgColor>, <oParent>, <lUnreadable>, <lProper>, <bPopUp>, <cPopCaption>, <cPopFont>, <oGet>, <nTimeOut>)



//
// H_LINE
//
#command @ <nRow>, <nCol> HLINE  ;
           [PARENT      <oParent>] ;
           [SIZE        [<nHeight>,<nWidth>]] ;
           [RAISED      <lRaised>] ;
           [FRAME       <lFrame>] ;
           [CAPTION     <cCaption>] ;
           [SAYWIDTH    <nSayWidth>] ;
=> ;
H_Line( <nRow>, <nCol>, @GetList, [@<oParent>], <nHeight>, <nWidth>, <lRaised>, <lFrame>, <cCaption>, <nSayWidth> )

*#command @ <nRow>, <nCol> HORIZONTAL ;
*           [PARENT       <oParent>] ;
*           [WIDTH        <nWidth>] ;
*           [LEN          <nLen>] ;
*           [RAISED       <lRaised> ] ;
*           [FRAME        <lFrame>] ;
*           [CAPTION      <cCaption>] ;
*=> ;
*H_Line( <nRow>, <nCol>, @GetList, [@<oParent>], <nWidth>, <nLen>, <lRaised>, <lFrame>, <cCaption> )

#command @ <nRow>, <nCol> HORIZONTAL ;
           [PARENT       <oParent>] ;
           [HEIGHT       <nHeight>] ;
           [WIDTH        <nWidth>] ;
           [RAISED       <lRaised> ] ;
           [FRAME        <lFrame>] ;
           [CAPTION      <cCaption>] ;
           [SAYWIDTH     <nSayWidth>] ;
=> ;
H_Line( <nRow>, <nCol>, @GetList, [@<oParent>], <nHeight>, <nWidth>, <lRaised>, <lFrame>, <cCaption>, <nSayWidth> )


/// H_GRALINE
#command @ <nRow>, <nCol> HGRALINE ;
           [PARENT       <oParent>] ;
           [WIDTH        <nWidth>] ;
           [RAISED       <lRaised> ] ;
           [FRAME        <lFrame>] ;
           [CAPTION      <cCaption>] ;
=> ;
H_GraLine( <nRow>, <nCol>, @GetList, [@<oParent>], <nWidth>, <lRaised>, <lFrame>, <cCaption> )


///  BUTTON_IMBED

#command @ <nRow>, <nCol> BUTTON_IMBED ;
         [ACTION <bAction> ] ;
         [CAPTION <bcnCaption>] ;
         OBJECT <oObject> ;
         [PARENT <oParent>] ;
         [ID <cId>]  ;
         [GROUP <cGroup>] ;
         [WHEN <bWhen>] ;
         [HIDE <bHide>] ;
         [ALIGN <nAlign>] ;
         [FONT <cFont>] ;
         [TOOLTIP <bcTooltip>] ;
 => ;
 POPUP_IMBED( <bcnCaption>, <bAction>, <oObject>, <oParent>, <nAlign>, <cId>, <cGroup>, <cFont>, <bWhen>, <bHide>, <bcTooltip>, <nRow>, <nCol>, @GetList)


*///  POPUP_IMBED
*
*#command POPUP_IMBED <bAction>  ;
*         [CAPTION <bcnCaption>] ;
*         OBJECT <oObject> ;
*         [PARENT <oParent>] ;
*         [ID <cId>]  ;
*         [GROUP <cGroup>] ;
*         [WHEN <bWhen>] ;
*         [HIDE <bHide>] ;
*         [ALIGN <nAlign>] ;
*         [FONT <cFont>] ;
*         [TOOLTIP <bcTooltip>] ;
*         [ROW <nRow>] ;
*         [COL <nCol>] ;
* => ;
* POPUP_IMBED( <bcnCaption>, <bAction>, <oObject>, <oParent>, <nAlign>, <cId>, <cGroup>, <cFont>, <bWhen>, <bHide>, <bcTooltip>, <nRow>, <nCol>, @GetList)

 #command POPUP_IMBED <bAction> ;
         [CAPTION <bcnCaption>] ;
         OBJECT <oObject> ;
         [PARENT <oParent>] ;
         [ID <cId>]  ;
         [GROUP <cGroup>] ;
         [WHEN <bWhen>] ;
         [HIDE <bHide>] ;
         [ALIGN <nAlign>] ;
         [FONT <cFont>] ;
         [TOOLTIP <bcTooltip>] ;
 => ;
 POPUP_IMBED(<bcnCaption>, <bAction>, <oObject>, <oParent>, <nAlign>, <cId>, <cGroup>, <cFont>, <bWhen>, <bHide>, <bcTooltip>, @GetList)





//
//  PRINT_TOFIT
//
#command PRINT_TOFIT [STRING     <cStr>] ;
                     [ROW        <nRow>] ;
                     [COL        <nCol>] ;
                     [WIDTH      <nWidth>] ;
                     [HEIGHT     <nHeight>] ;
                     [FONT       <cFont>] ;
                     [ROWSPACE   <nRowSpace>] ;
                     [MAX        <nMax>] ;
                     [EXCESS     <cExcess>] ;
=> Print_ToFit( <cStr>, <nRow>, <nCol>, <nWidth>, <nHeight>, <cFont>, <nRowSpace>, <nMax>, <cExcess> )


//
//  PRINT_MEMO
//
#command PRINT_MEMO  [STRING         <cStr>] ;
                     [HEADER         <aHeader>] ;
                     [PRINTER        <oPrinter>] ;
                     [LINEWIDTH      <nLineWidth>] ;
                     [LINESPERPAGE   <nLinesPerPage>] ;
                     [FONT           <cFont>] ;
                     [ROW            <nRow>] ;
                     [COL            <nCol>] ;
                     [PAGENUM        <lnPageNum>] ;
                     [PAGEMAX        <lnPageMax>] ;
                     [PAGENUMALIGN   <nPageNumAlign>] ;
                     [PAGESPRINTED   <nPagesPrinted>] ;
=> Print_Memo( <cStr>, <aHeader>, <oPrinter>, <nLineWidth>, <nLinesPerPage>, <cFont>, <nRow>, <nCol>, ;
               <lnPageNum>, <lnPageMax>, <nPageNumAlign>, <nPagesPrinted> )



//
// POPUP
//
#command POPUPBUTTON <bPopUp> ;
         [PARENT <oParent>] ;
         [REF <cId>]  ;
         [COLOR <ncFGc>, <ncBGc>] ;
         [GROUP <cGroup>] ;
         [WHEN <bWhen>] ;
         [HIDE <bHide>] ;
         [ID <cId>] ;
         [POPFONT <cFont>] ;
         [POPCAPTION <cCaption>] ;
         [POPTOOLTIP <cTooltip>] ;
=> ;
@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON ;
SIZE 20,20 PIXEL ;
ACTION {||Eval(<bPopUp>), DC_GetRefresh(GetList,<cId>)} ;
TABSTOP ;
[PARENT <oParent>] ;
[GROUP <cGroup>] ;
[COLOR <ncFGc>, <ncBGc>] ;
[WHEN <bWhen>] ;
[HIDE <bHide>] ;
[ID <cId>] ;
[FONT <cFont>] ;
[CAPTION <cCaption>] ;
[TOOLTIP <cTooltip>]


//
//  PROG_BAR
//
#xtranslate Prog_Bar(  EVENT       <nEvent>    [,]   ;
                       OBJECT      <oProg>     [,]   ;
                     [ COUNT       <nCnt>      [,] ] ;
                     [ TOTAL       <nTot>      [,] ] ;
                     [ CAPTION     <cText>     [,] ] ;
                     [ RADIUS      <nRadius>   [,] ] ;
                     [ OUTLINE     <lOutline>  [,] ] ;
                     [ DYNAMIC     <lDynamic>  [,] ] ;
                     [ VERTICAL    <lVertical> [,] ] ;
                     [ COLOR       <nColor>    [,] ] ;
                     [ COORDS      <aCoords>   [,] ] ;
                     [ TYPE        <nType>     [,] ] ;
                     )                               ;
=> ;
Prog_Bar( <nEvent>, <oProg>, <nCnt>, <nTot>, <cText>, <nRadius>, <lOutline>, <lDynamic>, <lVertical>, <nColor>, <aCoords>, <nType> )


//
//  Q_SEEK
//
#xtranslate Q_SEEK(   SEEK     <cSeek>       [,]  ;
                    [ ALIAS    <cAlias>     [,]] ;
                    [ ORDER    <nOrder>        ] ;
                    [ RETURN   <abReturn>      ] ;
                    [ LAST     <lLast>         ] ;
                  )                              ;
=> ;
Q_Seek( <cSeek>, <cAlias>, <nOrder>, <abReturn>, <lLast> )


//
//  RECSEEK - command translation of Rec_Seek()
//
#command QSEEK [ TO        <uReturn> ] ;
                 SEEK      <cSeek>     ;
               [ ALIAS    <cAlias>   ] ;
               [ ORDER    <nOrder>   ] ;
               [ RETURN   <abReturn> ] ;
               [ LAST     <lLast>    ] ;
=> ;
<uReturn> := Q_Seek( <cSeek>, <cAlias>, <nOrder>, <abReturn>, <lLast> )




//
//  REC_SEEK
//
#xtranslate Rec_Seek(  SEEK     <cSeek>        [,] ;
                     [ ALIAS    <cAlias>      [,]] ;
                     [ ORDER    <nOrder>         ] ;
                    )                              ;
=> ;
Rec_Seek( <cSeek>, <cAlias>, <nOrder>)


//
//  RECSEEK - command translation of Rec_Seek()
//
#command RECSEEK [TO        <uReturn>] ;
                  SEEK      <cSeek> ;
                 [ ALIAS    <cAlias>] ;
                 [ ORDER    <nOrder>] ;
                 [ RETURN   <abReturn>] ;
=> ;
<uReturn> := Rec_Seek( <cSeek>, <cAlias>, <nOrder>, <abReturn> )



//
// REC_ADD
//
#xtranslate Rec_Add( [ DB           <aDb>        [,] ] ;
                     [ BLOCK        <bCode>      [,] ] ;
                     [ TIMEOUT      <nTimeOut>   [,] ] ;
                     [ RETRY        <nReTry>     [,] ] ;
                     [ WAVE         <cWave>      [,] ] ;
                     )                                 ;
=> ;
Rec_Add( <aDb>, <bCode>, <nTimeOut>, <nReTry>, <cWave> )



//
// REC_LOCK
//
#xtranslate Rec_Lock( [ ALIAS        <cAlias>     [,] ] ;
                      [ ORDER        <nOrd>       [,] ] ;
                      [ RECORD       <nRec>       [,] ] ;
                      [ TIMEOUT      <nTimeOut>   [,] ] ;
                      [ WAVE         <cWave>      [,] ] ;
                     )                                  ;
=> ;
Rec_Lock( <cAlias>, <nOrd>, <nRec>, <nTimeOut>, <cWave> )




//
// REC_LOCKS
//
#xtranslate Rec_Locks( [ DB           <aLock>      [,] ] ;
                       [ ORDER        <nOrd>       [,] ] ;
                       [ RECORD       <nPos>       [,] ] ;
                       [ BLOCK        <bCode>      [,] ] ;
                       [ TIMEOUT      <nTimeOut>   [,] ] ;
                       [ RETRY        <nReTry>     [,] ] ;
                       [ WAVE         <cWave>      [,] ] ;
                     )                                   ;
=> ;
Rec_Locks( <aLock>, <nOrd>, <nPos>, <bCode>, <nTimeOut>, <nReTry>, <cWave> )



///  REC_SRCH
#xtranslate Rec_Srch(  SEEK      <cSeek>        [,]   ;
                     [ ALIAS     <cAlias>       [,] ] ;
                     [ ORDER     <nOrder>       [,] ] ;
                     [ RETURN    <bReturn>      [,] ] ;
                     [ FIRST     <lFirst>       [,] ] ;
                     [ SOFT      <lSoft>        [,] ] ;
                     [ RESTORE   <lRestore>     [,] ] ;
                     [ <lReturnObj:RETURNOBJ>       ] ;
                     [ RECOBJ    <oRecObj>      [,] ] ;
                     [ FIELDS    <acFields>     [,] ] ;
                     [ <lSetDeleted:SETDELETED>     ] ;
                   )                                 ;
=> ;
Rec_Srch( <cSeek>, <cAlias>, <nOrder>, <bReturn>, ;
          <lFirst>, <lSoft>, <lRestore>, <.lReturnObj.>, <oRecObj>, <acFields>, <.lSetDeleted.> )


///  RECSEARCH - command translation of Rec_Srch()
#command RECSEARCH  [TO         <uReturn>] ;
                    SEEK        <cSeek> ;
                    [ ALIAS     <cAlias>] ;
                    [ ORDER     <nOrder>] ;
                    [ RETURN    <bReturn>] ;
                    [ FIRST     <lFirst>] ;
                    [ SOFT      <lSoft>] ;
                    [ RESTORE   <lRestore>] ;
                    [ SETDELETED <lSetDeleted>] ;
                    [ <lReturnObj:RETURNOBJECT>] ;
                    [ RECOBJ    <oRecObj>] ;
                    [ FIELDS    <acFields>] ;
                    [ <lSetDeleted:SETDELETED>] ;
=> ;
<uReturn> := Rec_Srch( <cSeek>, <cAlias>, <nOrder>, <bReturn>, ;
                       <lFirst>, <lSoft>, <lRestore>, <.lReturnObj.>, <oRecObj>, <acFields>, <.lSetDeleted.> )


///  RECSRCH
#xtranslate RecSrch(  SEEK      <cSeek>        [,]   ;
                    [ ALIAS     <cAlias>       [,] ] ;
                    [ ORDER     <nOrder>       [,] ] ;
                    [ RETURN    <bReturn>      [,] ] ;
                    [ FIRST     <lFirst>       [,] ] ;
                    [ SOFT      <lSoft>        [,] ] ;
                    [ RESTORE   <lRestore>     [,] ] ;
                    [ <lReturnObj:RETURNOBJ>       ] ;
                    [ RECOBJ    <oRecObj>      [,] ] ;
                    [ FIELDS    <acFields>     [,] ] ;
                    [ <lSetDeleted:SETDELETED>     ] ;
                  )                                 ;
=> ;
RecSrch( <cSeek>, <cAlias>, <nOrder>, <bReturn>, <lFirst>, <lSoft>, <lRestore>, <.lReturnObj.>, <oRecObj>, <acFields>, <.lSetDeleted.> )


///  RECSRCH - command translation of RecSrch()
#command RECSRCH  [TO         <uReturn>] ;
                  SEEK        <cSeek> ;
                  [ ALIAS     <cAlias>] ;
                  [ ORDER     <nOrder>] ;
                  [ RETURN    <bReturn>] ;
                  [ FIRST     <lFirst>] ;
                  [ SOFT      <lSoft>] ;
                  [ RESTORE   <lRestore>] ;
                  [ <lReturnObj:RETURNOBJ>] ;
                  [ RECOBJ    <oRecObj>] ;
                  [ FIELDS    <acFields>] ;
                  [ <lSetDeleted:SETDELETED>] ;
=> ;
<uReturn> := Rec_Srch( <cSeek>, <cAlias>, <nOrder>, <bReturn>, <lFirst>, <lSoft>, <lRestore>, <.lReturnObj.>, <oRecObj>, <acFields>, <.lSetDeleted.> )



// TEXT_BOX

#command @ <nRow>, <nCol> TEXTBOX [<cText>]             ;
           [PARENT                 <oParent>]           ;
           [<font:FONT,SAYFONT> <cFont>]                ;
           [<color:COLOR,SAYCOLOR> <ncFgC> [,<ncBgC>]]  ;
           [<option:OPTIONS,SAYOPTIONS> <nOpt>]         ;
           [<size:SIZE,SAYSIZE> <nWidth> [,<nHeight>]]  ;
           [ID                     <cId>]               ;
           [GROUP                  <cGroup>]            ;
           [OBJECT                 <oObject>]           ;
           [HIDE                   <bHide>]             ;
           [WHEN                   <bWhen>]             ;
           [<tool:TOOLTIP,SAYTOOLTIP> <cToolTip>]       ;
 => ;
 Text_Box( <cText>, @GetList, @<oParent>, <nRow>, <nCol>, <cFont>, <ncFgC>, <ncBgC>, ;
           <nWidth>, <nHeight>, <nOpt>, <cId>, <cGroup>, <oObject>, <bHide>, <bWhen>, <cToolTip> )


//
// TIME_SPIN
//
#command @ <nRow>, <nCol> TIMESPIN [<cTime>] ;
           [PROMPT      <cPrompt>] ;
           [PARENT      <oParent>] ;
           [SAYSIZE     <nSaySize>] ;
           [ID          <cId>] ;
           [TOOLTIP     <cToolTip>] ;
  => ;
  Time_Spin( @<cTime>, <cPrompt>, @GetList, @<oParent>, <nRow>, <nCol>, ;
             <nSaySize>, <cId>, <cToolTip> )


//
// TIMESPINS
//
#command @ <nRow>, <nCol> TIMESPINS [<cTime>] ;
           [PROMPT       <cPrompt>] ;
           [PARENT       <oParent>] ;
           [SAYSIZE      <nSaySize>] ;
           [COLOR        <bnColor>] ;
           [ID           <cId>] ;
           [GROUP        <cGroup>] ;
           [EDITPROTECT  <bEditProtect>] ;
           [WHEN         <bWhen>] ;
           [ARIAL        <lArial>] ;
           [SECONDS      <lSeconds>] ;
           [TOOLTIP      <cToolTip>] ;

  => ;
  Time_Spins( @<cTime>, <cPrompt>, @GetList, [@<oParent>], <nRow>, <nCol>, ;
             <nSaySize>, <cId>, <cGroup>, <bEditProtect>, <bWhen>, <lArial>, <lSeconds>, <cToolTip>, <bnColor> )


//
// V_LINE
//
#command @ <nRow>, <nCol> VLINE  ;
           [PARENT       <oParent>] ;
           [SIZE        [<nWidth>],<nLen>] ;
           [RAISED       <lRaised>] ;
           [FRAME]       <lFrame>] ;
=> ;
V_Line( <nRow>, <nCol>, @GetList, [@<oParent>], <nWidth>, <nLen>, <lRaised>, <lFrame> )

#command @ <nRow>, <nCol> VERTICAL ;
           [PARENT       <oParent>] ;
           [WIDTH        <nWidth>] ;
           [LEN          <nLen>] ;
           [HEIGHT       <nHeight>] ;
           [RAISED       <lRaised> ] ;
           [FRAME        <lFrame>] ;
=> ;
V_Line( <nRow>, <nCol>, @GetList, @<oParent>, <nWidth>, [<nLen>][<nHeight>], <lRaised>, <lFrame> )


/// V_GRALINE
#command @ <nRow>, <nCol> VGRALINE ;
           [PARENT       <oParent>] ;
           [HEIGHT       <nHeight>] ;
           [RAISED       <lRaised> ] ;
           [FRAME        <lFrame>] ;
=> ;
V_GraLine( <nRow>, <nCol>, @GetList, [@<oParent>], <nHeight>, <lRaised>, <lFrame> )

//
// S P L I T _ S A Y
//
#command @ <nRow>, <nCol> DCSPLITSAY [<cSay1>,<cSay2>] ;
           [PARENT      <oParent>] ;
           [SIZE1       <nWidth1>[,<nLen1>]] ;
           [SIZE2       <nWidth2>[,<nLen2>]] ;
           [FONT        <cFont1>[,<cFont2>]] ;
           [ID          <cId>] ;
           [GROUP       <cGroup>] ;
           [DISTANCE    <nDist>] ;
           [TOOLTIP     <cToolTip>] ;
  => ;
  Split_Say( <cSay1>, <cSay2>, @GetList, @<oParent>, ;
   <nRow>, <nCol>, <nWidth1>, <nLen1>, <nWidth2>, <nLen2>, ;
   <cFont1>, <cFont2>, <cId>, <cGroup>, <nDist>, <cToolTip> )


//------------------------------------------------------------------------------
//
// GENERIC COMPILER MACROS FOR USE IN VARIOUS FUNCTIONS AND PROCEDURES
//

// TEST IF A DATABASE IS OPEN
#DEFINE IS_DB_OPEN(cAlias)  Select(cAlias) > 0


// DEFAULT CHARACTER, LOGICAL, ARRAY, NUMERIC BLOCK AND DATE VALUES.
#DEFINE DEF(VAR,VALUE) ;
            VAR := IIF(ValType(VALUE) == "C", ;                                   // If Character
                       IIF(!ValType(VAR) == "C" .OR. Empty(VAR), VALUE, VAR ), ;
                   IIF(ValType(VALUE) == "N", ;                                   // If Numeric
                       IIF(!ValType(VAR) == "N" .OR. ValType(VAR) == "U", VALUE, VAR ), ;
                   IIF(ValType(VALUE) == "L", ;                                   // If Logical
                       IIF(!ValType(VAR) == "L", VALUE, VAR ), ;
                   IIF(ValType(VALUE) == "A", ;                                   // If Array
                       IIF(!ValType(VAR) == "A" .OR. Empty(VAR), VALUE, VAR ), ;
                   IIF(ValType(VALUE) == "B", ;                                   // If CodeBlock
                       IIF(!ValType(VAR) == "B" .OR. ValType(VAR) == "U", VALUE, VAR ), ;
                   IIF(ValType(VALUE) == "D", ;                                   // If Date
                       IIF(Empty(VAR), VALUE, ;
                           IIF(ValType(VAR) == "C" .AND. At("/", VAR) > 0, CTOD(VAR), ;
                               IIF(!ValType(VAR) == "D", VALUE, VAR ))), VALUE ))))))

// DEFAULT CHARACTER
#DEFINE C_DEF(VAR,VARDEF)   VAR := IIF(ValType(VAR) == 'C', VAR, VARDEF)
#DEFINE C_EMPTY(VAR,VARDEF) VAR := IIF( Empty(VAR), VARDEF, VAR )
// DEFAULT LOGICAL
#DEFINE L_DEF(VAR,VARDEF)  VAR := IIF(ValType(VAR) == 'L', VAR, VARDEF)
// DEFAULT ARRAY
#DEFINE A_DEF(VAR,VARDEF)  VAR := IIF(ValType(VAR) == 'A' .AND. !Empty(VAR), VAR, VARDEF )
// DEFAULT NUMERIC
#DEFINE N_DEF(VAR,VARDEF)  VAR := IIF(ValType(VAR) == 'N', VAR, VARDEF)
// DEFAULT CODEBLOCK
#DEFINE B_DEF(VAR,VARDEF)  VAR := IIF(ValType(VAR) == 'B', VAR, VARDEF)
// DEFAULT DATE
#DEFINE D_DEF(VAR,VARDEF)  VAR := IIF(Empty(VAR), VARDEF, ;
                                  IIF(ValType(VAR) == 'C' .AND. At("/", VAR) > 0, CTOD(VAR), ;
                                  IIF(ValType(VAR) == 'D', VAR, VARDEF ) ) )

#DEFINE CN_DEF(VAR,VARDEF)   VAR := IIF(ValType(VAR) $'CN', VAR, VARDEF)



// DETERMINE THE LENGTH OF A VARIABLE: NUMERIC OR ALPHA
#DEFINE LEN_OF_VAR(PARM) IIF( ValType(PARM)=='C', Len(PARM), ;
                         IIF( ValType(PARM)=='N', Len(LTrim(Str(PARM))),;
                         IIF( ValType(PARM)=='D', 8, ;
                         IIF( ValType(PARM)=='L', 1, Len(PARM) ))))


// CONVERT EACH BEGINNING CHARACER IN A STRING TO UPPERCASE
#DEFINE PROPER_CASE(cString)  cString := TokenUpper(cString)


// EXTRACT A FILE NAME
#DEFINE GET_FNAME(PARM)  SubStr(PARM, 1, iif(At(".", PARM) > 0, At(".", PARM) - 1, Len(PARM) ))

// EXTRACT A FILE EXTENSION
#DEFINE GET_FEXT(PARM)   IIF( At(".", PARM) > 0, SubStr(PARM, At(".", PARM) + 1 ), Space(3) )




//----------------------------------------------------------------------------------------//
//
// F I L E _ P I C K
//

#xtranslate File_Pick( FILESPEC    <cFileSpec>  [,]   ;
                      [ INCLUDE    <aInclude>   [,] ] ;
                      [ EXCLUDE    <aExclude>   [,] ] ;
                      [ TOP_ROW    <nTr>        [,] ] ;
                      [ TOP_COL    <nTc>        [,] ] ;
                      [ COLOR      <cColor>     [,] ] ;
                      [ <lReturn:RETURN_DIR>    [,] ] ;
                      [ <lTag:TAG>              [,] ] ;
                      [ <lExt:DISP_EXT>         [,] ] ;
                      [ <lDate:DISP_DATE>       [,] ] ;
                      [ <lTime:DISP_TIME>       [,] ] ;
                      [ <lSize:DISP_SIZE>       [,] ] ;
                      [ <lAttr:DISP_ATTR>       [,] ] ;
                      [ ATTRTYPE   <cAttrType>      ] ;
                     )                                 ;
=> ;
File_Pick( <cFileSpec>, <aInclude>, <aExclude>, <nTr>, <nTc>, ;
           <cColor>, !<.lReturn.>, <.lTag.>, <.lExt.>, <.lDate.>, ;
           <.lTime.>, <.lSize.>, <.lAttr.>, <cAttrType> )





//
// I S R C H _ S X
//

#xtranslate ISrch_Sx(                              ;
                     [ DB       <uDb>        [,] ] ;
                     [ ORDER    <nOrder>     [,] ] ;
                     [ FORMAT   <nFormat>    [,] ] ;
                     [ GETS     <aGet>       [,] ] ;
                     [ SAYS     <aSay>       [,] ] ;
                     [ COLUMN   <aColumn>    [,] ] ;
                     [ WHILE    <aWhile>     [,] ] ;
                     [ COLORS   <aColor>     [,] ] ;
                     [ FREEZE   <nFreeze>    [,] ] ;
                     [ RETURN   <bReturn>    [,] ] ;
                     [ STUFF    <cStuff>     [,] ] ;
                     [ EDIT     <lEdit>      [,] ] ;
                     [ <lSearch:NO_GLOBAL>   [,] ] ;
                     [ <lClear:NO_CLEAR>     [,] ] ;
                     [ AUDIO    <lAudio>         ] ;
                    )                                ;
=> ;
ISrch_Sx( <uDb>, <nOrder>, <nFormat>, <aGet>, <aSay>, <aColumn>, ;
          <aWhile>, <aColor>, <nFreeze>, <bReturn>, <cStuff>, ;
          <lEdit>, !<.lSearch.>, !<.lClear.>, <.lAudio.> )









//
// E D L I T E _ C L
//

#xtranslate EdLite_Cl( <cText>,                       ;
                     [ <lMemoMode:MEMOMODE>    [,] ] ;
                     [ <lTextMode:TEXTMODE>    [,] ] ;
                     [ <lEditMode:EDITMODE>    [,] ] ;
                     [ WIN        <aWin>       [,] ] ;
                     [ PAGECHAR   <cPageChar>  [,] ] ;
                     [ RMARGIN    <nRMargin>   [,] ] ;
                     [ COLOR      <aColor>     [,] ] ;
                     [ OPTIONS    <aOptions>   [,] ] ;
                     [ PRINTCODES <aPrtOpt>    [,] ] ;
                     [ EXITKEYS   <aXKeys>     [,] ] ;
                     )                                 ;
=> ;
EdLite_Cl( <cText>, <.lMemoMode.>, <.lTextMode.>, <.lEditMode.>, ;
           <aWin>, <cPageChar>, <nRMargin>, ;
           <aColor>, <aOptions>, <aPrtOpt>, <aXKeys> )





#xtranslate AChoice_PK(  ARRAY      <aArray>        [,]   ;
                       [ TROW       <nTopRow>       [,] ] ;
                       [ TCOL       <nTopCol>       [,] ] ;
                       [ BROW       <nBotRow>       [,] ] ;
                       [ BCOL       <nBotCol>       [,] ] ;
                       [ LOGICALS   <aLogicals>     [,] ] ;
                       [ HILITENUM  <nHiLiteNum>    [,] ] ;
                       [ HILITEPOS  <nHiLitePos>    [,] ] ;
                       [ <lReturnVal:RETURN_POS>    [,] ] ;
                       [ ACOLOR     <cArrColor>     [,] ] ;
                       [ HCOLOR     <cHiColor>      [,] ] ;
                       [ UCOLOR     <cUnsColor>     [,] ] ;
                       [ CLWINTYPE  <nWin>          [,] ] ;
                       [ TITLE      <cTitle>        [,] ] ;
                       [ <lScrollBar:NO_SCROLLBAR>  [,] ] ;
                       [ <lIncrSrch:NO_SEARCH>      [,] ] ;
                       [ <lWrap:WRAPAROUND>         [,] ] ;
                       [ TOGGLE     <lToggle>       [,] ] ;
                       [ TOGCHAR    <cTogChar>      [,] ] ;
                       [ EXITKEYS   <XKeys>         [,] ] ;
                       [ STUFF      <cStuff>        [,] ] ;
                       [ WINGROW    <nGrow>         [,] ] ;
                       )                                    ;
=> ;
AChoice_Pk( <nTopRow>, <nTopCol>, <nBotRow>, <nBotCol>, ;
            <aArray>, <aLogicals>, ;
            <nHiLiteNum>, <nHiLitePos>, !<.lReturnVal.>, ;
            <cArrColor>, <cHiColor>, <cUnsColor>, <nWin>, <cTitle>, ;
            !<.lScrollBar.>, !<.lIncrSrch.>, <.lWrap.>, <lToggle>, ;
            <cTogChar>, <XKeys>, <cStuff>, <nGrow> )



#xtranslate AChoice_Pr(  EVENT      <nAction>       [,]   ;
                       [ ARRAY      <aArray>        [,] ] ;
                       [ OBJECT     <nWin>          [,] ] ;
                       [ TROW       <nTopRow>       [,] ] ;
                       [ TCOL       <nTopCol>       [,] ] ;
                       [ BROW       <nBotRow>       [,] ] ;
                       [ BCOL       <nBotCol>       [,] ] ;
                       [ LOGICALS   <aLogicals>     [,] ] ;
                       [ HILITENUM  <nHiLiteNum>    [,] ] ;
                       [ HILITEPOS  <nHiLitePos>    [,] ] ;
                       [ <lReturnVal:RETURN_POS>    [,] ] ;
                       [ ACOLOR     <cArrColor>     [,] ] ;
                       [ HCOLOR     <cHiColor>      [,] ] ;
                       [ UCOLOR     <cUnsColor>     [,] ] ;
                       [ CLWINTYPE  <nWinType>      [,] ] ;
                       [ TITLE      <cTitle>        [,] ] ;
                       [ <lScrollBar:NO_SCROLLBAR>  [,] ] ;
                       [ SEARCH     <lSearch>       [,] ] ;
                       [ <lWrap:WRAPAROUND>         [,] ] ;
                       [ TOGGLE     <lToggle>       [,] ] ;
                       [ TOGCHAR    <cTogChar>      [,] ] ;
                       [ EXITKEYS   <XKeys>         [,] ] ;
                       [ ALTEXIT    <lAltExit>      [,] ] ;
                       [ WINGROW    <nGrow>         [,] ] ;
                       )                                    ;
=> ;
AChoice_Pr( <nAction>, <nWin>, ;
            <nTopRow>, <nTopCol>, <nBotRow>, <nBotCol>, ;
            <aArray>, <aLogicals>, ;
            <nHiLiteNum>, <nHiLitePos>, !<.lReturnVal.>, ;
            <cArrColor>, <cHiColor>, <cUnsColor>, <nWinType>, <cTitle>, ;
            !<.lScrollBar.>, <lSearch>, <.lWrap.>, <lToggle>, ;
            <cTogChar>, <XKeys>, <lAltExit>, <nGrow> )










#xtranslate Dialog_Box(  TEXT       <cText>         [,]   ;
                       [ TROW       <nTr>           [,] ] ;
                       [ TCOL       <nTc>           [,] ] ;
                       [ HILITE     <nHilite>       [,] ] ;
                       [ CLWINTYPE  <nWin>          [,] ] ;
                       [ COLOR      <cColor>        [,] ] ;
                       [ SHADOW     <cShadow>       [,] ] ;
                       [ TITLE      <cTitle>        [,] ] ;
                       [ PROMPTS    <aPrompt>       [,] ] ;
                       [ TIMEOUT    <nTimeOut>      [,] ] ;
                       [ AUDIO      <uAudio>        [,] ] ;
                       [ HORIZONTAL <lHoriz>        [,] ] ;
                       [ <lBounce:BOUNCE>           [,] ] ;
                       [ DELAY      <nDelay>        [,] ] ;
                      )                                     ;
=> ;
Dialog_Box( <nTr>, <nTc>, <nHilite>, <nWin>, <cColor>, <cShadow>, ;
            <cTitle>, <cText>, <aPrompt>, <nTimeOut>, ;
            <uAudio>, <lHoriz>, <.lBounce.>, <nDelay> )






#xtranslate Get_WinVar(  GET        <uGet>          [,]   ;
                         SAY        <cTxt>          [,]   ;
                       [ PICTURE    <cPic>          [,] ] ;
                       [ COLOR      <cColor>        [,] ] ;
                       [ ALTGET     <cAltGet>       [,] ] ;
                       [ SECRET     <lSecret>       [,] ] ;
                       [ TROW       <nTr>           [,] ] ;
                       [ TCOL       <nTc>           [,] ] ;
                       [ <lPos:SAY_TOP>             [,] ] ;
                       [ SHADOW     <cShadow>       [,] ] ;
                       [ CLWINTYPE  <nWin>              ] ;
                       )                                    ;
=> ;
Get_WinVar( <uGet>, <cPic>, <cTxt>, <cColor>, <cAltGet>, <lSecret>, ;
            <nTr>, <nTc>,  <.lPos.>, <cShadow>, <nWin> )











#xtranslate Net_Lock(                                  ;
                     [ DB         <aLockWhat>    [,] ] ;
                     [ SECONDS    <nSec>         [,] ] ;
                     [ LOCKTYPE   <nLockType>    [,] ] ;
                     [ RECYCLE    <lReCycle>     [,] ] ;
                     [ CODE       <bCode>        [,] ] ;
                     [ TROW       <nRow>         [,] ] ;
                     [ TCOL       <nCol>         [,] ] ;
                     [ CLWINTYPE  <nWin>         [,] ] ;
                     [ COLOR      <cColor>       [,] ] ;
                     [ <lReset:RESETREC>         [,] ] ;
                     [ TIMEOUT    <nTimeOut>         ] ;
                    )                                    ;
=> ;
Net_Lock( <aLockWhat>, <nSec>, <nLockType>, <lReCycle>, <bCode>, ;
          <nRow>, <nCol>, <nWin>, <cColor>, <.lReset.>, <nTimeOut> )








#xtranslate Multi_Lock(                                 ;
                      [ ARRAY      <aLockInfo>    [,] ] ;
                      [ SECONDS    <nSec>         [,] ] ;
                      [ CODEBLOCK  <bCode>        [,] ] ;
                      [ ROW        <nRow>         [,] ] ;
                      [ COL        <nCol>         [,] ] ;
                      [ CLWINTYPE  <nWin>         [,] ] ;
                      [ COLOR      <cColor>       [,] ] ;
                      [ <lReset:RESETREC>         [,] ] ;
                     )                                    ;
=> ;
Multi_Lock( <aLockInfo>, <nSec>, <bCode>, ;
            <nRow>, <nCol>, <nWin>, <cColor>, <.lReset.> )










#xtranslate Hi_Menu(  MENU       <aMenu>         [,]   ;
                    [ HILITE     <nItem>         [,] ] ;
                    [ MCOLOR     <cClr>          [,] ] ;
                    [ HCOLOR     <cHClr>         [,] ] ;
                    [ KCOLOR     <cTClr>         [,] ] ;
                    [ CLWINTYPE  <nWin>          [,] ] ;
                    [ TITLE      <cTtl>          [,] ] ;
                    [ <lShad:NO_SHADOW>          [,] ] ;
                    [ <lTrig:FORCE_ENTER>        [,] ] ;
                    [ EXITKEYS   <aXKeys>            ] ;
                    )                                    ;
=> ;
Hi_Menu( <aMenu>, <nItem>, <cClr>, <cHClr>, <cTClr>, <nWin>, <cTtl>, ;
         !<.lShad.>, !<.lTrig.>, <aXKeys> )
















#xtranslate DbBrow_SX ( EVENT      <nEvent>       [,]   ;
                      [ OBJECT     <oBrowse>      [,] ] ;
                      [ DB         <cDb>          [,] ] ;
                      [ ORDER      <nOrder>       [,] ] ;
                      [ COLUMN     <aColumn>      [,] ] ;
                      [ COLSEP     <aSep>         [,] ] ;
                      [ POS        <uPos>         [,] ] ;
                      [ WHILE      <aWhile>       [,] ] ;
                      [ RETURN     <uReturn>      [,] ] ;
                      [ EDIT       <lEdit>        [,] ] ;
                      [ TAG        <lTag>         [,] ] ;
                      [ TAGOPT     <aTag>         [,] ] ;
                      [ FREEZE     <nFreeze>      [,] ] ;
                      [ SEARCH     <nSearch>      [,] ] ;
                      [ COORDS     <aCoords>      [,] ] ;
                      [ COLOR      <aColor>       [,] ] ;
                      [ BLOCK      <bBlock>       [,] ] ;
                      [ KEYS       <aKeys>        [,] ] ;
                      [ <lShad:NO_SHADOW>             ] ;
                      [ <lReset:RESET_WIN>            ] ;
                     )                                    ;
=> ;
DbBrow_SX( <oBrowse>, <nEvent>, <cDb>, <nOrder>, <aColumn>, <aSep>, ;
           <uPos>, <aWhile>, <uReturn>, <lEdit>, <lTag>, <aTag>, ;
           <nFreeze>, <nSearch>, <aCoords>, <aColor>, ;
           <bBlock>, <aKeys>, !<.lShad.>, <.lReset.> )






#xtranslate QDBrow_SX(                                   ;
                       [ DB         <cDb>          [,] ] ;
                       [ ORDER      <nOrder>       [,] ] ;
                       [ COLUMN     <aColumn>      [,] ] ;
                       [ COLSEP     <aSep>         [,] ] ;
                       [ POS        <uPos>         [,] ] ;
                       [ WHILE      <aWhile>       [,] ] ;
                       [ RETURN     <uReturn>      [,] ] ;
                       [ EDIT       <lEdit>        [,] ] ;
                       [ TAG        <lTag>         [,] ] ;
                       [ FREEZE     <nFreeze>      [,] ] ;
                       [ SEARCH     <nSearch>      [,] ] ;
                       [ COORDS     <aCoords>      [,] ] ;
                       [ COL        <nCol>         [,] ] ;
                       [ COLOR      <aColor>       [,] ] ;
                       [ BLOCK      <bBlock>       [,] ] ;
                       [ KEYS       <aKeys>            ] ;
                     )                                    ;
=> ;
QDBrow_SX( <cDb>, <nOrder>, <aColumn>, <aSep>, ;
           <uPos>, <aWhile>, <uReturn>, <lEdit>, <lTag>, ;
           <nFreeze>, <nSearch>, <aCoords>, <aColor>, ;
           <bBlock>, <aKeys> )









#xtranslate TBrow_SX(                                   ;
                      [ DB         <cDb>          [,] ] ;
                      [ ORDER      <nOrder>       [,] ] ;
                      [ COLUMN     <aColumn>      [,] ] ;
                      [ COLSEP     <aSep>         [,] ] ;
                      [ POS        <uPos>         [,] ] ;
                      [ WHILE      <aWhile>       [,] ] ;
                      [ RETURN     <uReturn>      [,] ] ;
                      [ EDIT       <lEdit>        [,] ] ;
                      [ DENYCOL    <aDenyCol>     [,] ] ;
                      [ FREEZE     <nFreeze>      [,] ] ;
                      [ SEARCH     <nSearch>      [,] ] ;
                      [ COORDS     <aCoords>      [,] ] ;
                      [ COLOR      <aColor>       [,] ] ;
                      [ BLOCK      <bBlock>       [,] ] ;
                      [ KEYS       <aKeys>        [,] ] ;
                      [ <lShad:NO_SHADOW>             ] ;
                    )                                    ;
=> ;
TBrow_SX( <cDb>, <nOrder>, <aColumn>, <aSep>, ;
          <uPos>, <aWhile>, <uReturn>, <lEdit>, <aDenyCol>, ;
          <nFreeze>, <nSearch>, <aCoords>, <aColor>, ;
          <bBlock>, <aKeys>, !<.lShad.> )









#xtranslate OBrow_Sx( EVENT        <nEvent>       [,]   ;
                      [ OBJECT     <oObject>      [,] ] ;
                      [ DB         <cDb>          [,] ] ;
                      [ ORDER      <nOrder>       [,] ] ;
                      [ COLUMN     <aColumn>      [,] ] ;
                      [ COLSEP     <aSep>         [,] ] ;
                      [ POS        <uPos>         [,] ] ;
                      [ WHILE      <aWhile>       [,] ] ;
                      [ RETURN     <uReturn>      [,] ] ;
                      [ EDIT       <lEdit>        [,] ] ;
                      [ FREEZE     <nFreeze>      [,] ] ;
                      [ SEARCH     <uSearch>      [,] ] ;
                      [ COORDS     <aCoords>      [,] ] ;
                      [ COLOR      <cColor>       [,] ] ;
                      [ BLOCK      <bBlock>       [,] ] ;
                      [ KEYS       <aKeys>        [,] ] ;
                      [ <lShad:NO_SHADOW>         [,] ] ;
                      [ RESETSCOPE <lScope>       [,] ] ;
                      [ EXITALLKEY <lExitAll>     [,] ] ;
                      [ FORCEDISP  <lForceDisp>   [,] ] ;
                      [ PASSTHRU   <lPassThru>    [,] ] ;
                      [ CLWIN      <lClWin>           ] ;
                    )                                    ;
=> ;
OBrow_Sx( <nEvent>, <oObject>, <cDb>, <nOrder>, <aColumn>, <aSep>, ;
          <uPos>, <aWhile>, <uReturn>, <lEdit>, ;
          <nFreeze>, <uSearch>, <aCoords>, <cColor>, ;
          <bBlock>, <aKeys>, !<.lShad.>, ;
          <lScope>, <lExitAll>, <lForceDisp>, <lPassThru>, <lClWin> )












#xtranslate LdRecs_Sx(                                  ;
                      [ DB         <cDb>          [,] ] ;
                      [ ORDER      <nOrd>         [,] ] ;
                      [ RETURN     <nReturn>      [,] ] ;
                      [ SEEK       <uSeek>        [,] ] ;
                      [ WHILE      <bWhile>       [,] ] ;
                      [ FOR        <bFor>         [,] ] ;
                      [ COORDS     <aCoord>       [,] ] ;
                      [ FIELDS     <aFldPos>      [,] ] ;
                      [ TITLE      <aFldTtl>      [,] ] ;
                      [ COLOR      <cColor>       [,] ] ;
                      [ BLOCK      <bCode>        [,] ] ;
                      [ TOGGLE     <lToggle>      [,] ] ;
                      [ TOGCHAR    <cTogChar>     [,] ] ;
                      [ SQUELCH    <lSquelch>     [,] ] ;
                      [ <lBackWards:REVERSE>          ] ;
                     )                                    ;
=> ;
LdRecs_Sx( <cDb>, <nOrd>, <nReturn>, <uSeek>, <bWhile>, <bFor>, ;
           <aCoord>, <aFldPos>, <aFldTtl>, <cColor>, <bCode>, ;
           <lToggle>, <cTogChar>, !<.lSquelch.>, <.lBackWards.> )









#xtranslate Indx_RDD(  INDEXES    <aIndex>       [,]   ;
                     [ <lAuto:AUTO_INDEX>        [,] ] ;
                     [ FILEOPTION <nFileOpt>     [,] ] ;
                     [ COLOR      <cColor>       [,] ] ;
                     [ CLEARSCN   <lClearScn>    [,] ] ;
                     [ AUDIO      <lAudio>           ] ;
                    )                                    ;
=> ;
Indx_RDD( <aIndex>, !<.lAuto.>, <nFileOpt>, <cColor>, ;
          <lClearScn>, <lAudio> )








#xtranslate Ed_Memo(  MEMO       <cMemo>         [,]   ;
                    [ COORDS     <aCoords>       [,] ] ;
                    [ EDIT       <lEdit>         [,] ] ;
                    [ TITLE      <cTitle>        [,] ] ;
                    [ LINELEN    <nLineLen>      [,] ] ;
                    [ POSDISP    <lPosDisp>      [,] ] ;
                    [ PRINTER    <aPrt>          [,] ] ;
                    [ BLOCK      <bBlock>        [,] ] ;
                    [ MEMCOLOR   <cMemColor>         ] ;
                   )                                     ;
=> ;
Ed_Memo( <cMemo>, <aCoords>, <lEdit>, <cTitle>, <nLineLen>, ;
         <lPosDisp>, <aPrt>, <bBlock>, <cMemColor> )







#xtranslate F_Create(  FILE       <cFile>         [,]   ;
                     [ STRING     <cStr>          [,] ] ;
                     [ COLOR      <cColor>        [,] ] ;
                     [ AUDIO      <lAudio>        [,] ] ;
                     [ MSG        <cMsg>          [,] ] ;
                     [ ATTR       <nAttr>         [,] ] ;
                     [ CLOSE      <lClose>            ] ;
                    )                                    ;
=> ;
F_Create( <cFile>, <cStr>, <cColor>, <lAudio>, <cMsg>, <nAttr>, <lClose> )

#command F_CREATE [ TO         <nHndle> ] ;
                    FILE       <cFile> ;
                  [ STRING     <cStr>   ] ;
                  [ COLOR      <cColor> ] ;
                  [ AUDIO      <lAudio> ] ;
                  [ MSG        <cMsg>   ] ;
                  [ ATTR       <nAttr>  ] ;
                  [ CLOSE      <lClose> ] ;
=> ;
<nHndle> := F_Create( <cFile>, <cStr>, <cColor>, <lAudio>, <cMsg>, <nAttr>, <lClose> )


#xtranslate F_Erase(  FILE       <cFile>         [,]   ;
                    [ COLOR      <cColor>        [,] ] ;
                    [ AUDIO      <lAudio>        [,] ] ;
                    [ MSG        <cMsg>          [,] ] ;
                   )                                    ;
=> ;
F_Erase( <cFile>, <cColor>, <lAudio>, <cMsg> )



#command  @ <nSRow>,<nSCol> TO <nERow>,<nECol> ;
          FORM_FIELD [HEADER <cHeader>] ;
                     [TEXT <cText>] ;
                     [HEADALIGN <nHdAlign>] ;
                     [HEADHEIGHT <nHdHeight>] ;
                     [HEADFONT <nHdFont>] ;
                     [HEADCOLOR <ncHdFgC> [,<ncHdBgC>]] ;
                     [HEADOBJ <oHdObj>] ;
                     [TEXTALIGN <nTxAlign>] ;
                     [TEXTFONT <nTxFont>] ;
                     [TEXTCOLOR <ncTxFgC> [,<ncTxBgC>]] ;
                     [TEXTOBJ <oTxObj>] ;
                     [BOXCOLOR <ncBxFgC> [,<ncBxBgC>]] ;
                     [HRADIUS <nHRadius>] ;
                     [VRADIUS <nVRadius>] ;
                     [PARENT <oParent>] ;
          => ;
          Form_Box( [<cHeader>], ;
                      [<cText>], ;
                      [<nSRow>], [<nSCol>], [<nERow>], [<nECol>], ;
                      [<nHdAlign>], ;
                      [<nHdHeight>], ;
                      [<nHdFont>], ;
                      [<ncHdFgC>], ;
                      [<ncHdBgC>], ;
                      [@<oHdObj>], ;
                      [<nTxAlign>], ;
                      [<nTxFont>], ;
                      [<ncTxFgC>], ;
                      [<ncTxBgC>], ;
                      [@<oTxObj>], ;
                      [<ncBxFgC>], ;
                      [<ncBxBgC>], ;
                      [<nHRadius>], ;
                      [<nVRadius>], ;
                      [@<oParent>], ;
                      GetList,;
                      .T., ;
                      .T. )

#command  @ <nSRow>,<nSCol> TO <nERow>,<nECol> ;
          FORM_BOX [BOXCOLOR <ncBxFgC> [,<ncBxBgC>]] ;
                   [HRADIUS <nHRadius>] ;
                   [VRADIUS <nVRadius>] ;
                   [PARENT <oParent>] ;
          => ;
          Form_Box( nil,;
                      nil,;
                      [<nSRow>], [<nSCol>], [<nERow>], [<nECol>], ;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      nil,;
                      [<ncBxFgC>], ;
                      [<ncBxBgC>], ;
                      [<nHRadius>], ;
                      [<nVRadius>], ;
                      [@<oParent>], ;
                      GetList,;
                      .F., ;
                      .T. )


#command  @ <nSRow>,<nSCol> TO <nERow>,<nECol> ;
          FORM_HEADER [HEADER <cHeader>] ;
                      [HEADALIGN <nHdAlign>] ;
                      [HEADHEIGHT <nHdHeight>] ;
                      [HEADFONT <nHdFont>] ;
                      [HEADCOLOR <ncHdFgC> [,<ncHdBgC>]] ;
                      [HEADOBJ <oHdObj>] ;
                      [HRADIUS <nHRadius>] ;
                      [VRADIUS <nVRadius>] ;
                      [PARENT <oParent>] ;
          => ;
          Form_Box( [<cHeader>], ;
                      nil,;
                      [<nSRow>], [<nSCol>], [<nERow>], [<nECol>], ;
                      [<nHdAlign>], ;
                      [<nHdHeight>], ;
                      [<nHdFont>], ;
                      [<ncHdFgC>], ;
                      [<ncHdBgC>], ;
                      [<oHdObj>], ;
                      nil, ;
                      nil, ;
                      nil, ;
                      nil, ;
                      nil, ;
                      nil, ;
                      nil, ;
                      [<nHRadius>], ;
                      [<nVRadius>], ;
                      [@<oParent>], ;
                      GetList,;
                      .T., ;
                      .F.  )



#xtranslate Pass_Win(  PASSWORD    <uPassWord>    [,]   ;
                     [ TITLE       <cTitle>       [,] ] ;
                     [ CHARTYPE    <nCharType>    [,] ] ;
                     [ COLOR       <cColor>       [,] ] ;
                     [ TROW        <nTRow>        [,] ] ;
                     [ TCOL        <nTCol>        [,] ] ;
                     [ TITLEPOS    <cTtlPos>          ] ;
                    )                                   ;
=> ;
Pass_Win( <uPassWord>, <cTitle>, <nCharType>, <cColor>, ;
          <nTRow>, <nTCol>, <cTtlPos> )






#xtranslate Prog_Bar(  EVENT       <nEvent>      [,]   ;
                     [ WIN         <nWin>        [,] ] ;
                     [ CURRENT     <nCurr>       [,] ] ;
                     [ TOTAL       <nTotal>      [,] ] ;
                     [ COLOR       <cColor>      [,] ] ;
                     [ TEXT        <cText>       [,] ] ;
                     [ ROW         <nBRow>       [,] ] ;
                     [ COL         <nBCol>       [,] ] ;
                     [ AUDIO       <lAudio>          ] ;
                     [ PAUSE       <nPause>          ] ;
                    )                                   ;
=> ;
Prog_Bar( <nEvent>, <nWin>, <nCurr>, <nTotal>, <cColor>, <cText>, ;
          <nBRow>, <nBCol>, <lAudio>, <nPause> )




#define BDMS_YELLOW  { 0, 255, 255 }


// Add Browse Column Command
#command ABC ;
         [HEADER <h>] ;
         [ELEMENT <n>] ;
         [FIELD <fld>] ;
         [DATA <d>] ;
         [PICTURE <pic>] ;
         [WIDTH <w>] ;
         [HEADPRESS <hp>] ;
         [HCOLOR <hc>] ;
         [COLOR <c>] ;
         [FONT <fnt>] ;
         [PROTECT <p> ] ;
         [WHEN <w> ] ;
         [TOOLTIP <t>] ;
         [SORT <s>] ;
         [TO <a>] ;
   => ;
AAdd( <a>, { <h>, [<n>] [<fld>] [<d>], <pic>, <w>, <hp>, <hc>, <c>, <fnt>, <p>, <w>, <t>, <s> } )

// start defines for Add Browse Column Array structure
#DEFINE ABC_HEADER       1
#DEFINE ABC_ELEMENT      2
#DEFINE ABC_FIELD        2
#DEFINE ABC_DATA         2
#DEFINE ABC_PICTURE      3
#DEFINE ABC_WIDTH        4
#DEFINE ABC_HEADPRES     5
#DEFINE ABC_HCOLOR       6
#DEFINE ABC_COLOR        7
#DEFINE ABC_FONT         8
#DEFINE ABC_PROTECT      9
#DEFINE ABC_WHEN        10
#DEFINE ABC_TOOLTIP     11
#DEFINE ABC_SORT        12


//
// DBPOPUP
//
#xtranslate DbPopUp( [ STRING       <cStr>          [,] ] ;
                     [ ALIAS        <acAlias>       [,] ] ;
                     [ ORDER        <nOrd>          [,] ] ;
                     [ BROWSE       <aBrow>         [,] ] ;
                     [ RETURN       <bReturn>       [,] ] ;
                     [ GETOBJECT    <oGet>          [,] ] ;
                     [ STATUS       <lStatus>       [,] ] ;
                     [ CODE         <bCode>         [,] ] ;
                     [ WHILE        <aWhile>        [,] ] ;
                     [ TITLE        <cTitle>        [,] ] ;
                     [ HIGHLIGHT    <aHighLight>    [,] ] ;
                     [ ITEMSELECTED <bItemSelected> [,] ] ;
                     [ HSCROLL      <lHScroll>      [,] ] ;
                     [ SIZE         <aSize>         [,] ] ;
                     [ FIND         <lFind>         [,] ] ;
                     [ NAVIGATE     <lNavigate>     [,] ] ;
                     [ VAL          <cVal>              ] ;
                   ) ;
=> ;
DbPopUp( <cStr>, <acAlias>, <nOrd>, <aBrow>, <bReturn>, <oGet>, <bCode>, <aWhile>, <cTitle>, ;
         <bItemSelected>, <aHighLight>, <lStatus>, <lHScroll>, <aSize>, <lFind>, <lNavigate>, <cVal> )

//
// D B N A V B A R
//
#xtranslate @ <nRow>, <nCol> DBNAVBAR  ;
              [ PARENT         <oParent> ] ;
              [ ALIAS          <cAlias> ] ;
              [ ORDER          <nOrd> ] ;
              [ OBJECT         <oBrowse> ] ;
              [ ARRAY          <aoFlds> ] ;
              [ RECOBJ         <aoFlds> ] ;
              [ SAVECODE       <bSave> ] ;
              [ CODEBLOCK      <bCode> ] ;
              [ SKIP           <aSkip> ] ;
              [ WHEN           <bWhen> ] ;
              [ HIDE           <bHide> ] ;
              [ HOTKEYS        <lHotKeys> ] ;
              [ SIZE           <aSize> ] ;
              [ VERTICAL       <lVert> ] ;
              [ BITMAP         <lBitMap> ] ;
              [ BUTTONS        <aButtons> ] ;
              [ OBJECT         <oObject> ] ;
              [ SQUARE         <lSquare> ] ;
              [ GROUP          <cGroup> ] ;
              [ XPSTYLE        <lXpStyle> ] ;
              [ <lNoText:NOTEXT>] [_NOTEXT <_lNotext>] ;
              [ LOADRECNO      <lLoadRecNo> ] ;
=> ;
DbNavBar( <nRow>, <nCol>, <oParent>, <cAlias>, <nOrd>, @GetList, <oBrowse>,;
          <aoFlds>, <bSave>, <bCode>, <aSkip>, <bWhen>, <aSize>, <lVert>, <lBitMap>, <aButtons>, ;
          <bHide>, <lHotKeys>, <oObject>, <lSquare>, <cGroup>, <lXpStyle>, <.lNoText.> [.OR. <_lNotext>], <lLoadRecNo> )


//
// SAVEREC
//
#xtranslate SAVEREC( [ ARRAY          <aoFld> ] ;
                     [ ALIAS          <cAlias> ] ;
                     [<lAdd:ADDREC>] [_ADDREC <_lAdd>] ;
                     [ CODE           <bCode> ] ;
                     [ BGNFLD         <nBgn> ] ;
                     [ ENDFLD         <nEnd> ] ;
                     [ WAVE           <nWave> ] ;
                     [ DISPLAY        <lDisp> ] ;
                     [ COMMIT         <lCommit> ] ;
                     [ RECNO          <nRec> ] ;
                     [ ANALYZE        <lAnalyze> ] ;
                    ) ;
=> ;
SaveRec( <aoFld>, <cAlias>, <.lAdd.> [.OR. <_lAdd>], <bCode>, <nBgn>, <nEnd>, <nWave>, <lDisp>, <lCommit>, <nRec>, <lAnalyze> )




#xcommand  SAVEREC [ ARRAY          <aoFld> ] ;
                   [ TO             <lSaved> ] ;
                   [ ALIAS          <cAlias> ] ;
                   [<lAdd:ADDREC>] [_ADDREC <_lAdd>] ;
                   [ CODE           <bCode> ] ;
                   [ BGNFLD         <nBgn> ] ;
                   [ ENDFLD         <nEnd> ] ;
                   [ WAVE           <nWave> ] ;
                   [ DISPLAY        <lDisp> ] ;
                   [ COMMIT         <lCommit> ] ;
                   [ RECNO          <nRec> ] ;
                   [ ANALYZE        <lAnalyze> ] ;
=> ;
<lSaved> := SaveRec( <aoFld>, <cAlias>, <.lAdd.> [.OR. <_lAdd>], <bCode>, <nBgn>, <nEnd>, <nWave>, <lDisp>, <lCommit>, <nRec>, <lAnalyze> )


/// Q SAVE
#xcommand  QSAVE [ ALIAS          <cAlias> ] ;
                 [ ORDER          <nOrder> ] ;
                 [ SEEKVAL        <cSeek> ] ;
                 [ KEYFLD         <nKeyFld> ] ;
                 [ ARRAY          <aFld> ] ;
                 [ WAVE           <nWave> ] ;
                 [ BGNFLD         <nBgn> ] ;
                 [ ENDFLD         <nEnd> ] ;
                 [<lAdd:ADDREC>] [_ADDREC <_lAdd>] ;
=> ;
MatchAndSave( <cAlias>, <nOrder>, <cSeek>, <nKeyFld>, <aFld>, <nWave>, <nBgn>, <nEnd>, <.lAdd.> [.OR. <_lAdd>] )



/// S A V E F L D S

#xtranslate SAVEFLDS( [ FLDS <aoRec> ] [ REC <aoRec> ] ;
                      [ BGNFLD        <acnBgn> ] ;
                      [ ENDFLD        <cnEnd> ] ;
                      [ WAVE          <cnWave> ] ;
                      [ CODE          <bCode> ] ;
                      [ APPEND        <lAppend> ] ;
                      [ CODE          <bCode> ] ;
                      [ DISPLAY       <lDisp> ] ;
                      [ COMMIT        <lCommit> ] ;
                      [ TRACK         <lTrackChanges> ] ;
                      [ EXCLUDE       <aExclude> ] ;
                    ) ;
=> ;
SaveFlds(<aoRec>, <acnBgn>, <cnEnd>, <cnWave>, <bCode>, <lAppend>, <lDisp>, <lCommit>, <lTrackChanges>, <aExclude> )



#xcommand  SAVEFLDS [ TO             <lSaved> ] ;
                    [ FLDS           <aoRec> ] ;
                    [ BGNFLD         <acnBgn> ] ;
                    [ ENDFLD         <cnEnd> ] ;
                    [ WAVE           <cnWave> ] ;
                    [ CODE           <bCode> ] ;
                    [ APPEND         <lAppend> ] ;
                    [ DISPLAY        <lDisp> ] ;
                    [ COMMIT         <lCommit> ] ;
                    [ TRACK          <lTrackChanges> ] ;
                    [ EXCLUDE        <aExclude> ] ;
=> ;
<lSaved> := SaveFlds(<aoRec>, <acnBgn>, <cnEnd>, <cnWave>, <bCode>, <lAppend>, <lDisp>, <lCommit>, <lTrackChanges>, <aExclude> )


/*
#command  @ <nRow> [,<nCol>] SAYGETHIDE <xVar>             ;
                [SIZE <nSize>]                             ;
                [FONT <cFont>]                             ;
                [SAYFONT <cSayFont>]                       ;
                [GETFONT <cGetFont>]                       ;
                [<color:COLOR> <nFgColor> [,<nBgColor>] ]  ;
                [TOOLTIP <cToolTip>]                       ;
                [SECONDS <nSeconds>]                       ;
                [POPUP <bPopUp>]                           ;
                [POPCAPTION <cPopCaption>]                 ;
                [POPFONT <cPopFont>]                       ;
                [POPKEY <k>]                               ;
                [POPTOOLTIP <cPopToolTip>]                 ;
=> SayGetHide(GetList, <nRow>, <nCol>, @<xVar>, IIF(Empty(<(cFont)>), <cSayFont>, <cFont>), IIF(Empty(<(cFont)>), <cGetFont>, <cFont>), ;
                       <nSize>, <nFgColor>, <nBgColor>, <cToolTip>, @<nSeconds>, <bPopUp>, <cPopCaption>, <cPopFont>, <k>, <cPopToolTip>)
*/
#command  @ <nRow> [,<nCol>] SAYGETHIDE <xVar>             ;
                [SIZE <nSize>]                             ;
                [SAYFONT <cSayFont>]                       ;
                [GETFONT <cGetFont>]                       ;
                [<color:COLOR> <nFgColor> [,<nBgColor>] ]  ;
                [TOOLTIP <cToolTip>]                       ;
                [VALID <bValid>]                           ;
                [PARENT <oParent>]                         ;
                [SECONDS <nSeconds>]                       ;
                [POPUP <bPopUp>]                           ;
                [POPCAPTION <cPopCaption>]                 ;
                [POPFONT <cPopFont>]                       ;
                [POPKEY <k>]                               ;
                [POPTOOLTIP <cPopToolTip>]                 ;
=> SayGetHide(GetList, <nRow>, <nCol>, @<xVar>, <cSayFont>, <cGetFont>, <nSize>, <nFgColor>, <nBgColor>, <cToolTip>, <bValid>, <oParent>, @<nSeconds>,;
             <bPopUp>, <cPopCaption>, <cPopFont>, <k>, <cPopToolTip>)




#xcommand  SENDMAIL[ SENDER         <cSender> ] ;
                   [ RECIPIENT      <cRecipient> ] ;
                   [ SUBJECT        <cSubject> ] ;
                   [ TEXT           <cText> ] ;
                   [ SMTPUSER       <cSmtpUser> ] ;
                   [ SMTPPASSWORD   <cSmtpPassword> ] ;
                   [ SMTPSERVER     <cSmtpServer> ] ;
                   [ SMTPPORT       <cSmtpPort> ] ;
                   [ REPLYTO        <cReplyTo> ] ;
                   [ CC             <cCc> ] ;
                   [ ATTACHMENT     <cAttachment> ] ;
                   [ TYPE           <cType> ] ;
                   [ PATH           <cPath> ] ;
                   [ SILENT         <lSilent> ] ;
=> ;
SendMail( <cSender>, <cRecipient>, <cSubject>, <cText>, <cSmtpUser>, <cSmtpPassword>, <cSmtpServer>, <cSmtpPort>, <cReplyTo>, <cCc>, <cAttachment>, <cType>, <cPath>, <lSilent> )


#xcommand  SENDMAILTHREAD[ SENDER         <cSender> ] ;
                         [ RECIPIENT      <cRecipient> ] ;
                         [ SUBJECT        <cSubject> ] ;
                         [ TEXT           <cText> ] ;
                         [ SMTPUSER       <cSmtpUser> ] ;
                         [ SMTPPASSWORD   <cSmtpPassword> ] ;
                         [ SMTPSERVER     <cSmtpServer> ] ;
                         [ SMTPPORT       <cSmtpPort> ] ;
                         [ REPLYTO        <cReplyTo> ] ;
                         [ CC             <cCc> ] ;
                         [ ATTACHMENT     <cAttachment> ] ;
                         [ TYPE           <cType> ] ;
                         [ PATH           <cPath> ] ;
                         [ SILENT         <lSilent> ] ;
=> ;
SendMailThread( <cSender>, <cRecipient>, <cSubject>, <cText>, <cSmtpUser>, <cSmtpPassword>, <cSmtpServer>, <cSmtpPort>, <cReplyTo>, <cCc>, <cAttachment>, <cType>, <cPath>, <lSilent> )

